//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>
#include <Foundation/Foundation.h>

#ifndef DEBUG_ENUNCIATE
//turn off enunciate debugging.
#define DEBUG_ENUNCIATE 0
#endif

/**
 * Enunciate-specific interfaces and protocols.
 */
#ifndef ENUNCIATE_OBJC_TYPES
#define ENUNCIATE_OBJC_TYPES

/**
 * Protocol defining an Enunciate XML I/O methods.
 */
@protocol EnunciateXML

/**
 * Read an instance from XML.
 *
 * @param xml The XML to read.
 */
+ (id<EnunciateXML>) readFromXML: (NSData *) xml;

/**
 * Write this instance as XML.
 *
 * @return The XML.
 */
- (NSData *) writeToXML;

@end /*protocol EnunciateXML*/


/**
 * A basic XML node. Can be an element or an attribute. Used
 * instead of NSXMLElement because it's not supported on all
 * platforms yet.
 */
@interface JAXBBasicXMLNode : NSObject
{
  @private
    NSString *_name;
    NSString *_ns;
    NSString *_prefix;
    NSString *_value;
    NSArray  *_childElements;
    NSArray  *_attributes;
}

/**
 * Accessor for the (local) name of the XML node.
 *
 * @return The (local) name of the XML node.
 */
- (NSString *) name;

/**
 * Accessor for the (local) name of the XML node.
 *
 * @param newName The (local) name of the XML node.
 */
- (void) setName: (NSString *) newName;

/**
 * Accessor for the namespace of the XML node.
 *
 * @return The namespace of the XML node.
 */
- (NSString *) ns;

/**
 * Accessor for the namespace of the XML node.
 *
 * @param newNs The namespace of the XML node.
 */
- (void) setNs: (NSString *) newNs;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @return The namespace prefix of the XML node.
 */
- (NSString *) prefix;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @param newPrefix The namespace prefix of the XML node.
 */
- (void) setPrefix: (NSString *) newPrefix;

/**
 * Accessor for the value of the XML node.
 *
 * @return The value of the XML node.
 */
- (NSString *) value;

/**
 * Accessor for the value of the XML node.
 *
 * @param newValue The value of the XML node.
 */
- (void) setValue: (NSString *) newValue;

/**
 * Accessor for the child elements of the XML node.
 *
 * @return The child elements of the XML node.
 */
- (NSArray *) childElements;

/**
 * Accessor for the child elements of the XML node.
 *
 * @param newValue The child elements of the XML node.
 */
- (void) setChildElements: (NSArray *) newChildElements;

/**
 * Accessor for the attributes of the XML node.
 *
 * @return The attributes of the XML node.
 */
- (NSArray *) attributes;

/**
 * Accessor for the attributes of the XML node.
 *
 * @param newAttributes The attributes of the XML node.
 */
- (void) setAttributes: (NSArray *) newAttributes;
@end /*interface JAXBBasicXMLNode*/

#endif /* ENUNCIATE_OBJC_TYPES */


@class NEXUS_CAPABILITIES_PLUGINNS0CapabilityResource;
@class NEXUS_CAPABILITIES_PLUGINNS0FormFieldResource;
@class NEXUS_CAPABILITIES_PLUGINNS0NexusResponse;
@class NEXUS_CAPABILITIES_PLUGINNS0CapabilityTypeResource;
@class NEXUS_CAPABILITIES_PLUGINNS0CapabilityPropertyResource;
@class NEXUS_CAPABILITIES_PLUGINNS0CapabilityListItemResource;
@class NEXUS_CAPABILITIES_PLUGINNS0CapabilityTypeResourceResponse;
@class NEXUS_CAPABILITIES_PLUGINNS0CapabilityStatusResponseResource;
@class NEXUS_CAPABILITIES_PLUGINNS0CapabilityRequestResource;
@class NEXUS_CAPABILITIES_PLUGINNS0CapabilityResponseResource;
@class NEXUS_CAPABILITIES_PLUGINNS0CapabilityFormFieldResource;
@class NEXUS_CAPABILITIES_PLUGINNS0CapabilitiesListResponseResource;

#ifndef DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityResource_H
#define DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityResource_H

/**
 *  The capability configuration.
 
 @version $Revision$ $Date$

 */
@interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityResource : NSObject
{
  @private
    NSString *_id;
    NSString *_name;
    NSString *_typeId;
    NSArray *_properties;
}

/**
 * The id of the capability.
 */
- (NSString *) id;

/**
 * The id of the capability.
 */
- (void) setId: (NSString *) newId;

/**
 * The name of the capability.
 */
- (NSString *) name;

/**
 * The name of the capability.
 */
- (void) setName: (NSString *) newName;

/**
 * The type id of the capability.
 */
- (NSString *) typeId;

/**
 * The type id of the capability.
 */
- (void) setTypeId: (NSString *) newTypeId;

/**
 * Field properties.
 */
- (NSArray *) properties;

/**
 * Field properties.
 */
- (void) setProperties: (NSArray *) newProperties;
@end /* interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityResource */

#endif /* DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityResource_H */
#ifndef DEF_NEXUS_CAPABILITIES_PLUGINNS0FormFieldResource_H
#define DEF_NEXUS_CAPABILITIES_PLUGINNS0FormFieldResource_H

/**
 * (no documentation provided)
 */
@interface NEXUS_CAPABILITIES_PLUGINNS0FormFieldResource : NSObject
{
  @private
    NSString *_type;
    NSString *_label;
    BOOL _required;
    NSString *_id;
    NSString *_regexValidation;
    NSString *_helpText;
}

/**
 * (no documentation provided)
 */
- (NSString *) type;

/**
 * (no documentation provided)
 */
- (void) setType: (NSString *) newType;

/**
 * (no documentation provided)
 */
- (NSString *) label;

/**
 * (no documentation provided)
 */
- (void) setLabel: (NSString *) newLabel;

/**
 * (no documentation provided)
 */
- (BOOL) required;

/**
 * (no documentation provided)
 */
- (void) setRequired: (BOOL) newRequired;

/**
 * (no documentation provided)
 */
- (NSString *) id;

/**
 * (no documentation provided)
 */
- (void) setId: (NSString *) newId;

/**
 * (no documentation provided)
 */
- (NSString *) regexValidation;

/**
 * (no documentation provided)
 */
- (void) setRegexValidation: (NSString *) newRegexValidation;

/**
 * (no documentation provided)
 */
- (NSString *) helpText;

/**
 * (no documentation provided)
 */
- (void) setHelpText: (NSString *) newHelpText;
@end /* interface NEXUS_CAPABILITIES_PLUGINNS0FormFieldResource */

#endif /* DEF_NEXUS_CAPABILITIES_PLUGINNS0FormFieldResource_H */
#ifndef DEF_NEXUS_CAPABILITIES_PLUGINNS0NexusResponse_H
#define DEF_NEXUS_CAPABILITIES_PLUGINNS0NexusResponse_H

/**
 * (no documentation provided)
 */
@interface NEXUS_CAPABILITIES_PLUGINNS0NexusResponse : NSObject
{
  @private
}
@end /* interface NEXUS_CAPABILITIES_PLUGINNS0NexusResponse */

#endif /* DEF_NEXUS_CAPABILITIES_PLUGINNS0NexusResponse_H */
#ifndef DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityTypeResource_H
#define DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityTypeResource_H

/**
 *  Capability type, which you can configure a capability against.
 
 @version $Revision$ $Date$

 */
@interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityTypeResource : NSObject
{
  @private
    NSString *_id;
    NSString *_name;
    NSArray *_formFields;
}

/**
 * The id of capability type.
 */
- (NSString *) id;

/**
 * The id of capability type.
 */
- (void) setId: (NSString *) newId;

/**
 * The name of capability type.
 */
- (NSString *) name;

/**
 * The name of capability type.
 */
- (void) setName: (NSString *) newName;

/**
 * Field formFields.
 */
- (NSArray *) formFields;

/**
 * Field formFields.
 */
- (void) setFormFields: (NSArray *) newFormFields;
@end /* interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityTypeResource */

#endif /* DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityTypeResource_H */
#ifndef DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityPropertyResource_H
#define DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityPropertyResource_H

/**
 *  A configuration property for a capability.
 
 @version $Revision$ $Date$

 */
@interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityPropertyResource : NSObject
{
  @private
    NSString *_key;
    NSString *_value;
}

/**
 * The key of the property.
 */
- (NSString *) key;

/**
 * The key of the property.
 */
- (void) setKey: (NSString *) newKey;

/**
 * The value of the property.
 */
- (NSString *) value;

/**
 * The value of the property.
 */
- (void) setValue: (NSString *) newValue;
@end /* interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityPropertyResource */

#endif /* DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityPropertyResource_H */
#ifndef DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityListItemResource_H
#define DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityListItemResource_H

/**
 *  Capabilities list item details.
 
 @version $Revision$ $Date$

 */
@interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityListItemResource : NSObject
{
  @private
    NSString *_resourceURI;
    NSString *_id;
    NSString *_name;
    NSString *_typeId;
    NSString *_typeName;
}

/**
 * The URL that can be used to manage the capability.
 */
- (NSString *) resourceURI;

/**
 * The URL that can be used to manage the capability.
 */
- (void) setResourceURI: (NSString *) newResourceURI;

/**
 * The id of the capability.
 */
- (NSString *) id;

/**
 * The id of the capability.
 */
- (void) setId: (NSString *) newId;

/**
 * The name of the capability.
 */
- (NSString *) name;

/**
 * The name of the capability.
 */
- (void) setName: (NSString *) newName;

/**
 * The type id of the capability.
 */
- (NSString *) typeId;

/**
 * The type id of the capability.
 */
- (void) setTypeId: (NSString *) newTypeId;

/**
 * The type name of the capability.
 */
- (NSString *) typeName;

/**
 * The type name of the capability.
 */
- (void) setTypeName: (NSString *) newTypeName;
@end /* interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityListItemResource */

#endif /* DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityListItemResource_H */
#ifndef DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityTypeResourceResponse_H
#define DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityTypeResourceResponse_H

/**
 *  REST Response object for a capability type list request,
 contains the typical 'data' parameter, which is the capability
 type details.
 
 @version $Revision$ $Date$

 */
@interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityTypeResourceResponse : NEXUS_CAPABILITIES_PLUGINNS0NexusResponse <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * Field data.
 */
- (NSArray *) data;

/**
 * Field data.
 */
- (void) setData: (NSArray *) newData;
@end /* interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityTypeResourceResponse */

#endif /* DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityTypeResourceResponse_H */
#ifndef DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityStatusResponseResource_H
#define DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityStatusResponseResource_H

/**
 *  REST Response object for a capability configuration add/update
 operation, contains the typical 'data' parameter, which is the
 capability configuration.
 
 @version $Revision$ $Date$

 */
@interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityStatusResponseResource : NEXUS_CAPABILITIES_PLUGINNS0NexusResponse <EnunciateXML>
{
  @private
    NEXUS_CAPABILITIES_PLUGINNS0CapabilityListItemResource *_data;
}

/**
 * The capability status.
 */
- (NEXUS_CAPABILITIES_PLUGINNS0CapabilityListItemResource *) data;

/**
 * The capability status.
 */
- (void) setData: (NEXUS_CAPABILITIES_PLUGINNS0CapabilityListItemResource *) newData;
@end /* interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityStatusResponseResource */

#endif /* DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityStatusResponseResource_H */
#ifndef DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityRequestResource_H
#define DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityRequestResource_H

/**
 *  REST Request object for a capability configuration add/update
 operation, contains the typical 'data' parameter, which is the
 capability configuration.
 
 @version $Revision$ $Date$

 */
@interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityRequestResource : NEXUS_CAPABILITIES_PLUGINNS0NexusResponse <EnunciateXML>
{
  @private
    NEXUS_CAPABILITIES_PLUGINNS0CapabilityResource *_data;
}

/**
 * The capability configuration.
 */
- (NEXUS_CAPABILITIES_PLUGINNS0CapabilityResource *) data;

/**
 * The capability configuration.
 */
- (void) setData: (NEXUS_CAPABILITIES_PLUGINNS0CapabilityResource *) newData;
@end /* interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityRequestResource */

#endif /* DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityRequestResource_H */
#ifndef DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityResponseResource_H
#define DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityResponseResource_H

/**
 *  REST Response object for a capability configuration request,
 contains the typical 'data' parameter, which is the capability
 configuration.
 
 @version $Revision$ $Date$

 */
@interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityResponseResource : NEXUS_CAPABILITIES_PLUGINNS0NexusResponse <EnunciateXML>
{
  @private
    NEXUS_CAPABILITIES_PLUGINNS0CapabilityResource *_data;
}

/**
 * The capability configuration.
 */
- (NEXUS_CAPABILITIES_PLUGINNS0CapabilityResource *) data;

/**
 * The capability configuration.
 */
- (void) setData: (NEXUS_CAPABILITIES_PLUGINNS0CapabilityResource *) newData;
@end /* interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityResponseResource */

#endif /* DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityResponseResource_H */
#ifndef DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityFormFieldResource_H
#define DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityFormFieldResource_H

/**
 *  Class CapabilityFormFieldResource.
 
 @version $Revision$ $Date$

 */
@interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityFormFieldResource : NEXUS_CAPABILITIES_PLUGINNS0FormFieldResource
{
  @private
}
@end /* interface NEXUS_CAPABILITIES_PLUGINNS0CapabilityFormFieldResource */

#endif /* DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilityFormFieldResource_H */
#ifndef DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilitiesListResponseResource_H
#define DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilitiesListResponseResource_H

/**
 *  REST Response object for a list of capabilities items, contains
 the typical 'data' parameter, which is the list of capabilities.
 
 @version $Revision$ $Date$

 */
@interface NEXUS_CAPABILITIES_PLUGINNS0CapabilitiesListResponseResource : NEXUS_CAPABILITIES_PLUGINNS0NexusResponse <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * Field data.
 */
- (NSArray *) data;

/**
 * Field data.
 */
- (void) setData: (NSArray *) newData;
@end /* interface NEXUS_CAPABILITIES_PLUGINNS0CapabilitiesListResponseResource */

#endif /* DEF_NEXUS_CAPABILITIES_PLUGINNS0CapabilitiesListResponseResource_H */
