//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>

#ifndef DEBUG_ENUNCIATE
#define DEBUG_ENUNCIATE 0
#endif

#ifndef ENUNCIATE_C_UTILITIES
#define ENUNCIATE_C_UTILITIES

/**
 * A basic xml node, used when (de)serializing unknown or "any" xml type.
 * We can't use the libxml xmlNodePtr because we can't reliably "free" it.
 */
struct xmlBasicNode {
  /**
   * The (local) name of the node.
   */
  xmlChar *name;

  /**
   * The namespace of the node.
   */
  xmlChar *ns;

  /**
   * The namespace prefix of the node.
   */
  xmlChar *prefix;

  /**
   * The (text) value of the node.
   */
  xmlChar *value;

  /**
   * The child elements of the node.
   */
  struct xmlBasicNode *child_elements;

  /**
   * The attributes of the node.
   */
  struct xmlBasicNode *attributes;

  /**
   * The next sibling (for a list of nodes).
   */
  struct xmlBasicNode *sibling;
};

/*******************xml utilities************************************/

static int xmlTextReaderAdvanceToNextStartOrEndElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderRead(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static int xmlTextReaderSkipElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderNext(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static xmlChar *xmlTextReaderReadEntireNodeValue(xmlTextReaderPtr reader) {
  xmlChar *buffer = calloc(1, sizeof(xmlChar));
  const xmlChar *snippet;
  int status;
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ATTRIBUTE) {
    return xmlTextReaderValue(reader);
  }
  else if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status && (xmlTextReaderNodeType(reader) == XML_READER_TYPE_TEXT || xmlTextReaderNodeType(reader) == XML_READER_TYPE_CDATA || xmlTextReaderNodeType(reader) == XML_READER_TYPE_ENTITY_REFERENCE)) {
      snippet = xmlTextReaderConstValue(reader);
      buffer = realloc(buffer, (xmlStrlen(buffer) + xmlStrlen(snippet) + 1) * sizeof(xmlChar));
      xmlStrcat(buffer, snippet);
      status = xmlTextReaderRead(reader);
    }
  }
  return buffer;
}

/*******************base 64 utilities************************************/

/*
 * Base64 Translation Table as described in RFC1113.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cb64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

/*
 * Base64 Translation Table to decode (created by author)
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cd64[]="|$$$}rstuvwxyz{$$$$$$$>?@ABCDEFGHIJKLMNOPQRSTUVW$$$$$$XYZ[\\]^_`abcdefghijklmnopq";

/*
 * encode 3 8-bit binary bytes as 4 '6-bit' characters
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param in the block to encode
 * @param out the block to encode to
 * @param len the length of the 'in' block.
 */
static void _encode_base64_block(unsigned char in[3], unsigned char out[4], int len) {
  out[0] = cb64[ in[0] >> 2 ];
  out[1] = cb64[ ((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4) ];
  out[2] = (unsigned char) (len > 1 ? cb64[ ((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6) ] : '=');
  out[3] = (unsigned char) (len > 2 ? cb64[ in[2] & 0x3f ] : '=');
}

/*
 * decode 4 '6-bit' characters into 3 8-bit binary bytes
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static void _decode_base64_block( unsigned char in[4], unsigned char out[3] )
{
    out[ 0 ] = (unsigned char ) (in[0] << 2 | in[1] >> 4);
    out[ 1 ] = (unsigned char ) (in[1] << 4 | in[2] >> 2);
    out[ 2 ] = (unsigned char ) (((in[2] << 6) & 0xc0) | in[3]);
}

/*
 * base64 encode a stream adding padding and line breaks as per spec.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param instream The stream to encode.
 * @param insize The size of the stream to encode.
 * @return The encoded string.
 */
xmlChar *_encode_base64(unsigned char *instream, int insize) {
  unsigned char in[3];
  unsigned char out[4];
  xmlChar *encoded;
  int i, in_index = 0, out_index = 0, blocklen;

  if (insize == 0) {
    return BAD_CAST "\0";
  }

  encoded = calloc(((insize / 3) * 4) + 10, sizeof(xmlChar));
  while (in_index <= insize) {
    blocklen = 0;
    for (i = 0; i < 3; i++) {
      in[i] = instream[in_index++];
      if (in_index <= insize) {
        blocklen++;
      }
      else {
        in[i] = 0;
      }
    }
    if (blocklen) {
      _encode_base64_block(in, out, blocklen);
      for( i = 0; i < 4; i++ ) {
        encoded[out_index++] = out[i];
      }
    }
  }

  return encoded;
}

/*
 * Decode a base64 encoded stream discarding padding, line breaks and noise
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param invalue The string to decode.
 * @param outsize Holder for the length of the returned data.
 * @return The decoded data.
 */
unsigned char *_decode_base64( const xmlChar *invalue, int *outsize ) {
  xmlChar in[4];
  unsigned char out[3], v;
  int i, in_index = 0, out_index = 0, blocklen;
  unsigned char *outstream;

  if (invalue == NULL) {
    return NULL;
  }

  outstream = calloc(((xmlStrlen(invalue) / 4) * 3) + 1, sizeof(unsigned char));
  while (invalue[in_index] != '\0') {
    for (blocklen = 0, i = 0; i < 4 && invalue[in_index]; i++) {
      v = 0;
      while (invalue[in_index] != '\0' && v == 0) {
        v = (unsigned char) invalue[in_index++];
        v = (unsigned char) ((v < 43 || v > 122) ? 0 : cd64[ v - 43 ]);
        if (v) {
          v = (unsigned char) ((v == '$') ? 0 : v - 61);
        }
      }

      if (invalue[in_index] != '\0') {
        blocklen++;
        if (v) {
          in[i] = (unsigned char) (v - 1);
        }
      }
      else {
        in[i] = 0;
      }
    }

    if (blocklen) {
      _decode_base64_block( in, out );
      for( i = 0; i < blocklen - 1; i++ ) {
        outstream[out_index++] = out[i];
      }
    }
  }

  if (outsize != NULL) {
    *outsize = out_index;
  }

  return outstream;
}

#endif /* ENUNCIATE_C_UTILITIES */

#ifndef BASIC_XML_FUNCTIONS_Xs
#define BASIC_XML_FUNCTIONS_Xs

/*******************xs:boolean************************************/

/**
 * Read a boolean value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to 1 if "true" was read. pointer to 0 otherwise.
 */
static int *xmlTextReaderReadXsBooleanType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = (xmlStrcmp(BAD_CAST "true", nodeValue) == 0) ? 1 : 0;
  free(nodeValue);
  return value;
}

/**
 * Write a boolean value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsBooleanType(xmlTextWriterPtr writer, int *value) {
  if (*value) {
    return xmlTextWriterWriteString(writer, BAD_CAST "false");
  }
  else {
    return xmlTextWriterWriteString(writer, BAD_CAST "true");
  }
}

/**
 * Frees a boolean type from memory.
 *
 * @param value The value to free.
 */
static void freeXsBooleanType(int *value) {
  //no-op
}

/*******************xs:byte************************************/

/**
 * Read a byte value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the byte.
 */
static unsigned char *xmlTextReaderReadXsByteType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  unsigned char *value = malloc(sizeof(unsigned char));
  *value = (unsigned char) atoi((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a byte value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsByteType(xmlTextWriterPtr writer, unsigned char *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a byte type from memory.
 *
 * @param value The value to free.
 */
static void freeXsByteType(unsigned char *value) {
  //no-op
}

/*******************xs:double************************************/

/**
 * Read a double value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the double.
 */
static double *xmlTextReaderReadXsDoubleType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  double *value = malloc(sizeof(double));
  *value = atof((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a double value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDoubleType(xmlTextWriterPtr writer, double *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a double type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDoubleType(double *value) {
  //no-op
}

/*******************xs:float************************************/

/**
 * Read a float value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the float.
 */
static float *xmlTextReaderReadXsFloatType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  float *value = malloc(sizeof(float));
  *value = atof((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a float value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsFloatType(xmlTextWriterPtr writer, float *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a float type from memory.
 *
 * @param value The value to free.
 */
static void freeXsFloatType(float *value) {
  //no-op
}

/*******************xs:int************************************/

/**
 * Read a int value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @param value The value to be written.
 * @return pointer to the int.
 */
static int *xmlTextReaderReadXsIntType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = atoi((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a int value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntType(xmlTextWriterPtr writer, int *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a int type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntType(int *value) {
  //no-op
}

/*******************xs:long************************************/

/**
 * Read a long value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the long.
 */
static long *xmlTextReaderReadXsLongType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  long *value = malloc(sizeof(long));
  *value = atol((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a long value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsLongType(xmlTextWriterPtr writer, long *value) {
  return xmlTextWriterWriteFormatString(writer, "%ld", *value);
}

/**
 * Frees a long type from memory.
 *
 * @param value The value to free.
 */
static void freeXsLongType(long *value) {
  //no-op
}

/*******************xs:short************************************/

/**
 * Read a short value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the short.
 */
static short *xmlTextReaderReadXsShortType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  short *value = malloc(sizeof(short));
  *value = atoi((char *)nodeValue);
  return value;
}

/**
 * Write a short value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsShortType(xmlTextWriterPtr writer, short *value) {
  return xmlTextWriterWriteFormatString(writer, "%hi", *value);
}

/**
 * Frees a short type from memory.
 *
 * @param value The value to free.
 */
static void freeXsShortType(short *value) {
  //no-op
}

/*******************xs:string************************************/

/**
 * Read a string value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the string.
 */
static xmlChar *xmlTextReaderReadXsStringType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadEntireNodeValue(reader);
}

/**
 * Write a string value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsStringType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a string type from memory.
 *
 * @param value The value to free.
 */
static void freeXsStringType(xmlChar *value) {
  //no-op
}

/*******************xs:ID************************************/

/**
 * Read a ID value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the ID.
 */
static xmlChar *xmlTextReaderReadXsIDType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a ID value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a ID type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:IDREF************************************/

/**
 * Read a IDREF value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the IDREF.
 */
static xmlChar *xmlTextReaderReadXsIDREFType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a IDREF value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDREFType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a IDREF type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDREFType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:integer************************************/

/**
 * Read a (big) integer value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the integer.
 */
static xmlChar *xmlTextReaderReadXsIntegerType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a integer value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntegerType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a integer type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntegerType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:decimal************************************/

/**
 * Read a (big) decimal value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the decimal.
 */
static xmlChar *xmlTextReaderReadXsDecimalType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a decimal value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDecimalType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a decimal type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDecimalType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:duration************************************/

/**
 * Read a duration value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the duration.
 */
static xmlChar *xmlTextReaderReadXsDurationType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a duration value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDurationType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a duration type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDurationType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:QName************************************/

/**
 * Read a QName value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the QName.
 */
static xmlChar *xmlTextReaderReadXsQNameType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a QName value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsQNameType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a QName type from memory.
 *
 * @param value The value to free.
 */
static void freeXsQNameType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:anyURI************************************/

/**
 * Read a anyURI value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyURI.
 */
static xmlChar *xmlTextReaderReadXsAnyURIType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a anyURI value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyURIType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a anyURI type from memory.
 *
 * @param value The value to free.
 */
static void freeXsAnyURIType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:dateTime************************************/

/**
 * Read a dateTime value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the dateTime.
 */
static struct tm *xmlTextReaderReadXsDateTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-ddThh:MM:ss+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to 'T' character.
  token_index = 0;
  while (index < len && timevalue[index] != 'T') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mday = atoi(token);
  if (token_index > 0) {
    success++; //assume 'day' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a dateTime value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02iT%02i:%02i:%02i.000%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a dateTime type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateTimeType(struct tm *value) {
  //no-op
}

/*******************xs:time************************************/

/**
 * Read a time value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the time.
 */
static struct tm *xmlTextReaderReadXsTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: hh:MM:ss+oo:oo
  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a time value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%02i:%02i:%02i.000%+03i:%02i", value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a time type from memory.
 *
 * @param value The value to free.
 */
static void freeXsTimeType(struct tm *value) {
  //no-op
}

/*******************xs:date************************************/

/**
 * Read a date value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the date.
 */
static struct tm *xmlTextReaderReadXsDateType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-dd+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a date value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02i%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a date type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateType(struct tm *value) {
  //no-op
}

/*******************xs:anyType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnyTypeType(struct xmlBasicNode *node) {
  if (node->attributes != NULL) {
    freeXsAnyTypeType(node->attributes);
  }
  if (node->value != NULL) {
    free(node->value);
  }
  if (node->child_elements != NULL) {
    freeXsAnyTypeType(node->child_elements);
  }
  if (node->name != NULL) {
    free(node->name);
  }
  if (node->prefix != NULL) {
    free(node->prefix);
  }
  if (node->ns != NULL) {
    free(node->ns);
  }
  if (node->sibling != NULL) {
    freeXsAnyTypeType(node->sibling);
    free(node->sibling);
  }
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *child, *next, *node = calloc(1, sizeof(struct xmlBasicNode));
  int status, depth = xmlTextReaderDepth(reader);
  const xmlChar *text;

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);

  if (xmlTextReaderHasAttributes(reader)) {
    child = NULL;
    while (xmlTextReaderMoveToNextAttribute(reader)) {
      next = calloc(1, sizeof(struct xmlBasicNode));
      if (child == NULL) {
        node->attributes = next;
      }
      else {
        child->sibling = next;
      }
      child = next;
      child->name = xmlTextReaderLocalName(reader);
      child->ns = xmlTextReaderNamespaceUri(reader);
      child->prefix = xmlTextReaderPrefix(reader);
      child->value = xmlTextReaderValue(reader);
    }

    status = xmlTextReaderMoveToElement(reader);
    if (status < 1) {
      //panic: unable to return to the element node.
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status == 1 && xmlTextReaderDepth(reader) > depth) {
      switch (xmlTextReaderNodeType(reader)) {
        case XML_READER_TYPE_ELEMENT:
          child = xmlTextReaderReadXsAnyTypeType(reader);
          if (child == NULL) {
            //panic: xml read error
            freeXsAnyTypeType(node);
            free(node);
            return NULL;
          }

          next = node->child_elements;
          if (next == NULL) {
            node->child_elements = child;
          }
          else {
            while (1) {
              if (next->sibling == NULL) {
                next->sibling = child;
                break;
              }
              next = next->sibling;
            }
          }

          break;
        case XML_READER_TYPE_TEXT:
        case XML_READER_TYPE_CDATA:
          text = xmlTextReaderConstValue(reader);
          node->value = xmlStrncat(node->value, text, xmlStrlen(text));
          break;
        default:
          //skip anything else.
          break;
      }

      status = xmlTextReaderRead(reader);
    }

    if (status < 1) {
      //panic: xml read error
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  int status;
  int totalBytes = 0;
  struct xmlBasicNode *next;

  status = xmlTextWriterStartElementNS(writer, node->prefix, node->name, node->ns);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  next = node->attributes;
  while (next != NULL) {
    status = xmlTextWriterWriteAttributeNS(writer, next->prefix, next->name, next->ns, next->value);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  if (node->value != NULL) {
    status = xmlTextWriterWriteString(writer, node->value);
    if (status < 0) {
      //panic: xml write error
      return status;
    }
    totalBytes += status;
  }

  next = node->child_elements;
  while (next != NULL) {
    status = xmlTextWriterWriteXsAnyTypeType(writer, next);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Read a anyType element value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeElement(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsAnyTypeType(reader);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElement(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElementNS(xmlTextWriterPtr writer, struct xmlBasicNode *node, int writeNamespaces) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Free a anyType element value.
 *
 * @param node The node.
 */
static void freeXsAnyTypeElement(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/*******************xs:anySimpleType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnySimpleTypeType(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnySimpleTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *node = calloc(1, sizeof(struct xmlBasicNode));

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);
  node->value = xmlTextReaderReadEntireNodeValue(reader);

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnySimpleTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  if (node->value != NULL) {
    return xmlTextWriterWriteXsStringType(writer, node->value);
  }

  return 0;
}

#endif /* BASIC_XML_FUNCTIONS_Xs */

#ifndef DEF_nexus_capabilities_plugin_ns0_capabilitiesListResponseResource_H
#define DEF_nexus_capabilities_plugin_ns0_capabilitiesListResponseResource_H

/**
 *  REST Response object for a list of capabilities items, contains
 the typical 'data' parameter, which is the list of capabilities.
 
 @version $Revision$ $Date$

 */
struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource {


  /**
   * Field data.
   */
  struct nexus_capabilities_plugin_ns0_capabilities_list_resource *data;

  /**
   * Size of the data array.
   */
  int _sizeof_data;
};

/**
 * Reads a CapabilitiesListResponseResource element from XML. The element to be read is "capabilities-list", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The CapabilitiesListResponseResource, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *xml_read_nexus_capabilities_plugin_ns0_capabilitiesListResponseResource(xmlTextReaderPtr reader);

/**
 * Writes a CapabilitiesListResponseResource to XML under element name "capabilities-list".
 *
 * @param writer The XML writer.
 * @param _capabilitiesListResponseResource The CapabilitiesListResponseResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_capabilities_plugin_ns0_capabilitiesListResponseResource(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *_capabilitiesListResponseResource);

/**
 * Frees a CapabilitiesListResponseResource.
 *
 * @param _capabilitiesListResponseResource The CapabilitiesListResponseResource to free.
 */
void free_nexus_capabilities_plugin_ns0_capabilitiesListResponseResource(struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *_capabilitiesListResponseResource);

/**
 * Reads a CapabilitiesListResponseResource element from XML. The element to be read is "capabilities-list", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The CapabilitiesListResponseResource, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *xmlTextReaderReadNs0Capabilities_listElement(xmlTextReaderPtr reader);

/**
 * Writes a CapabilitiesListResponseResource to XML under element name "capabilities-list".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _capabilitiesListResponseResource The CapabilitiesListResponseResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Capabilities_listElement(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *_capabilitiesListResponseResource);

/**
 * Writes a CapabilitiesListResponseResource to XML under element name "capabilities-list".
 *
 * @param writer The XML writer.
 * @param _capabilitiesListResponseResource The CapabilitiesListResponseResource to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Capabilities_listElementNS(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *_capabilitiesListResponseResource, int writeNamespaces);

/**
 * Frees the children of a CapabilitiesListResponseResource.
 *
 * @param _capabilitiesListResponseResource The CapabilitiesListResponseResource whose children are to be free.
 */
static void freeNs0Capabilities_listElement(struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *_capabilitiesListResponseResource);

/**
 * Reads a CapabilitiesListResponseResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The CapabilitiesListResponseResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *xmlTextReaderReadNs0CapabilitiesListResponseResourceType(xmlTextReaderPtr reader);

/**
 * Writes a CapabilitiesListResponseResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilitiesListResponseResource The CapabilitiesListResponseResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CapabilitiesListResponseResourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *_capabilitiesListResponseResource);

/**
 * Frees the elements of a CapabilitiesListResponseResource.
 *
 * @param _capabilitiesListResponseResource The CapabilitiesListResponseResource to free.
 */
static void freeNs0CapabilitiesListResponseResourceType(struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *_capabilitiesListResponseResource);

#endif /* DEF_nexus_capabilities_plugin_ns0_capabilitiesListResponseResource_H */
#ifndef DEF_nexus_capabilities_plugin_ns0_capabilityFormFieldResource_H
#define DEF_nexus_capabilities_plugin_ns0_capabilityFormFieldResource_H

/**
 *  Class CapabilityFormFieldResource.
 
 @version $Revision$ $Date$

 */
struct nexus_capabilities_plugin_ns0_capabilityFormFieldResource {


  /**
   * (no documentation provided)
   */
  xmlChar *type;

  /**
   * (no documentation provided)
   */
  xmlChar *label;

  /**
   * (no documentation provided)
   */
  int required;

  /**
   * (no documentation provided)
   */
  xmlChar *id;

  /**
   * (no documentation provided)
   */
  xmlChar *regexValidation;

  /**
   * (no documentation provided)
   */
  xmlChar *helpText;
};

/**
 * Reads a CapabilityFormFieldResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The CapabilityFormFieldResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capabilityFormFieldResource *xmlTextReaderReadNs0CapabilityFormFieldResourceType(xmlTextReaderPtr reader);

/**
 * Writes a CapabilityFormFieldResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityFormFieldResource The CapabilityFormFieldResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CapabilityFormFieldResourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityFormFieldResource *_capabilityFormFieldResource);

/**
 * Frees the elements of a CapabilityFormFieldResource.
 *
 * @param _capabilityFormFieldResource The CapabilityFormFieldResource to free.
 */
static void freeNs0CapabilityFormFieldResourceType(struct nexus_capabilities_plugin_ns0_capabilityFormFieldResource *_capabilityFormFieldResource);

#endif /* DEF_nexus_capabilities_plugin_ns0_capabilityFormFieldResource_H */
#ifndef DEF_nexus_capabilities_plugin_ns0_capabilities_list_resource_H
#define DEF_nexus_capabilities_plugin_ns0_capabilities_list_resource_H

/**
 *  Capabilities list item details.
 
 @version $Revision$ $Date$

 */
struct nexus_capabilities_plugin_ns0_capabilities_list_resource {


  /**
   * The URL that can be used to manage the capability.
   */
  xmlChar *resourceURI;

  /**
   * The id of the capability.
   */
  xmlChar *id;

  /**
   * The name of the capability.
   */
  xmlChar *name;

  /**
   * The type id of the capability.
   */
  xmlChar *typeId;

  /**
   * The type name of the capability.
   */
  xmlChar *typeName;
};

/**
 * Reads a CapabilityListItemResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The CapabilityListItemResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capabilities_list_resource *xmlTextReaderReadNs0Capabilities_list_resourceType(xmlTextReaderPtr reader);

/**
 * Writes a CapabilityListItemResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityListItemResource The CapabilityListItemResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Capabilities_list_resourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilities_list_resource *_capabilityListItemResource);

/**
 * Frees the elements of a CapabilityListItemResource.
 *
 * @param _capabilityListItemResource The CapabilityListItemResource to free.
 */
static void freeNs0Capabilities_list_resourceType(struct nexus_capabilities_plugin_ns0_capabilities_list_resource *_capabilityListItemResource);

#endif /* DEF_nexus_capabilities_plugin_ns0_capabilities_list_resource_H */
#ifndef DEF_nexus_capabilities_plugin_ns0_capability_property_resource_H
#define DEF_nexus_capabilities_plugin_ns0_capability_property_resource_H

/**
 *  A configuration property for a capability.
 
 @version $Revision$ $Date$

 */
struct nexus_capabilities_plugin_ns0_capability_property_resource {


  /**
   * The key of the property.
   */
  xmlChar *key;

  /**
   * The value of the property.
   */
  xmlChar *value;
};

/**
 * Reads a CapabilityPropertyResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The CapabilityPropertyResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capability_property_resource *xmlTextReaderReadNs0Capability_property_resourceType(xmlTextReaderPtr reader);

/**
 * Writes a CapabilityPropertyResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityPropertyResource The CapabilityPropertyResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Capability_property_resourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capability_property_resource *_capabilityPropertyResource);

/**
 * Frees the elements of a CapabilityPropertyResource.
 *
 * @param _capabilityPropertyResource The CapabilityPropertyResource to free.
 */
static void freeNs0Capability_property_resourceType(struct nexus_capabilities_plugin_ns0_capability_property_resource *_capabilityPropertyResource);

#endif /* DEF_nexus_capabilities_plugin_ns0_capability_property_resource_H */
#ifndef DEF_nexus_capabilities_plugin_ns0_capabilityRequestResource_H
#define DEF_nexus_capabilities_plugin_ns0_capabilityRequestResource_H

/**
 *  REST Request object for a capability configuration add/update
 operation, contains the typical 'data' parameter, which is the
 capability configuration.
 
 @version $Revision$ $Date$

 */
struct nexus_capabilities_plugin_ns0_capabilityRequestResource {


  /**
   * The capability configuration.
   */
  struct nexus_capabilities_plugin_ns0_capability_resource *data;
};

/**
 * Reads a CapabilityRequestResource element from XML. The element to be read is "capability", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The CapabilityRequestResource, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilityRequestResource *xml_read_nexus_capabilities_plugin_ns0_capabilityRequestResource(xmlTextReaderPtr reader);

/**
 * Writes a CapabilityRequestResource to XML under element name "capability".
 *
 * @param writer The XML writer.
 * @param _capabilityRequestResource The CapabilityRequestResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_capabilities_plugin_ns0_capabilityRequestResource(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityRequestResource *_capabilityRequestResource);

/**
 * Frees a CapabilityRequestResource.
 *
 * @param _capabilityRequestResource The CapabilityRequestResource to free.
 */
void free_nexus_capabilities_plugin_ns0_capabilityRequestResource(struct nexus_capabilities_plugin_ns0_capabilityRequestResource *_capabilityRequestResource);

/**
 * Reads a CapabilityRequestResource element from XML. The element to be read is "capability", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The CapabilityRequestResource, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilityRequestResource *xmlTextReaderReadNs0CapabilityElement(xmlTextReaderPtr reader);

/**
 * Writes a CapabilityRequestResource to XML under element name "capability".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _capabilityRequestResource The CapabilityRequestResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CapabilityElement(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityRequestResource *_capabilityRequestResource);

/**
 * Writes a CapabilityRequestResource to XML under element name "capability".
 *
 * @param writer The XML writer.
 * @param _capabilityRequestResource The CapabilityRequestResource to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CapabilityElementNS(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityRequestResource *_capabilityRequestResource, int writeNamespaces);

/**
 * Frees the children of a CapabilityRequestResource.
 *
 * @param _capabilityRequestResource The CapabilityRequestResource whose children are to be free.
 */
static void freeNs0CapabilityElement(struct nexus_capabilities_plugin_ns0_capabilityRequestResource *_capabilityRequestResource);

/**
 * Reads a CapabilityRequestResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The CapabilityRequestResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capabilityRequestResource *xmlTextReaderReadNs0CapabilityRequestResourceType(xmlTextReaderPtr reader);

/**
 * Writes a CapabilityRequestResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityRequestResource The CapabilityRequestResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CapabilityRequestResourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityRequestResource *_capabilityRequestResource);

/**
 * Frees the elements of a CapabilityRequestResource.
 *
 * @param _capabilityRequestResource The CapabilityRequestResource to free.
 */
static void freeNs0CapabilityRequestResourceType(struct nexus_capabilities_plugin_ns0_capabilityRequestResource *_capabilityRequestResource);

#endif /* DEF_nexus_capabilities_plugin_ns0_capabilityRequestResource_H */
#ifndef DEF_nexus_capabilities_plugin_ns0_capability_resource_H
#define DEF_nexus_capabilities_plugin_ns0_capability_resource_H

/**
 *  The capability configuration.
 
 @version $Revision$ $Date$

 */
struct nexus_capabilities_plugin_ns0_capability_resource {


  /**
   * The id of the capability.
   */
  xmlChar *id;

  /**
   * The name of the capability.
   */
  xmlChar *name;

  /**
   * The type id of the capability.
   */
  xmlChar *typeId;

  /**
   * Field properties.
   */
  struct nexus_capabilities_plugin_ns0_capability_property_resource *properties;

  /**
   * Size of the properties array.
   */
  int _sizeof_properties;
};

/**
 * Reads a CapabilityResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The CapabilityResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capability_resource *xmlTextReaderReadNs0Capability_resourceType(xmlTextReaderPtr reader);

/**
 * Writes a CapabilityResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityResource The CapabilityResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Capability_resourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capability_resource *_capabilityResource);

/**
 * Frees the elements of a CapabilityResource.
 *
 * @param _capabilityResource The CapabilityResource to free.
 */
static void freeNs0Capability_resourceType(struct nexus_capabilities_plugin_ns0_capability_resource *_capabilityResource);

#endif /* DEF_nexus_capabilities_plugin_ns0_capability_resource_H */
#ifndef DEF_nexus_capabilities_plugin_ns0_capabilityResponseResource_H
#define DEF_nexus_capabilities_plugin_ns0_capabilityResponseResource_H

/**
 *  REST Response object for a capability configuration request,
 contains the typical 'data' parameter, which is the capability
 configuration.
 
 @version $Revision$ $Date$

 */
struct nexus_capabilities_plugin_ns0_capabilityResponseResource {


  /**
   * The capability configuration.
   */
  struct nexus_capabilities_plugin_ns0_capability_resource *data;
};

/**
 * Reads a CapabilityResponseResource element from XML. The element to be read is "capability", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The CapabilityResponseResource, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilityResponseResource *xml_read_nexus_capabilities_plugin_ns0_capabilityResponseResource(xmlTextReaderPtr reader);

/**
 * Writes a CapabilityResponseResource to XML under element name "capability".
 *
 * @param writer The XML writer.
 * @param _capabilityResponseResource The CapabilityResponseResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_capabilities_plugin_ns0_capabilityResponseResource(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityResponseResource *_capabilityResponseResource);

/**
 * Frees a CapabilityResponseResource.
 *
 * @param _capabilityResponseResource The CapabilityResponseResource to free.
 */
void free_nexus_capabilities_plugin_ns0_capabilityResponseResource(struct nexus_capabilities_plugin_ns0_capabilityResponseResource *_capabilityResponseResource);

/**
 * Reads a CapabilityResponseResource element from XML. The element to be read is "capability", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The CapabilityResponseResource, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilityResponseResource *xmlTextReaderReadNs0CapabilityElement(xmlTextReaderPtr reader);

/**
 * Writes a CapabilityResponseResource to XML under element name "capability".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _capabilityResponseResource The CapabilityResponseResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CapabilityElement(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityResponseResource *_capabilityResponseResource);

/**
 * Writes a CapabilityResponseResource to XML under element name "capability".
 *
 * @param writer The XML writer.
 * @param _capabilityResponseResource The CapabilityResponseResource to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CapabilityElementNS(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityResponseResource *_capabilityResponseResource, int writeNamespaces);

/**
 * Frees the children of a CapabilityResponseResource.
 *
 * @param _capabilityResponseResource The CapabilityResponseResource whose children are to be free.
 */
static void freeNs0CapabilityElement(struct nexus_capabilities_plugin_ns0_capabilityResponseResource *_capabilityResponseResource);

/**
 * Reads a CapabilityResponseResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The CapabilityResponseResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capabilityResponseResource *xmlTextReaderReadNs0CapabilityResponseResourceType(xmlTextReaderPtr reader);

/**
 * Writes a CapabilityResponseResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityResponseResource The CapabilityResponseResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CapabilityResponseResourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityResponseResource *_capabilityResponseResource);

/**
 * Frees the elements of a CapabilityResponseResource.
 *
 * @param _capabilityResponseResource The CapabilityResponseResource to free.
 */
static void freeNs0CapabilityResponseResourceType(struct nexus_capabilities_plugin_ns0_capabilityResponseResource *_capabilityResponseResource);

#endif /* DEF_nexus_capabilities_plugin_ns0_capabilityResponseResource_H */
#ifndef DEF_nexus_capabilities_plugin_ns0_capabilityStatusResponseResource_H
#define DEF_nexus_capabilities_plugin_ns0_capabilityStatusResponseResource_H

/**
 *  REST Response object for a capability configuration add/update
 operation, contains the typical 'data' parameter, which is the
 capability configuration.
 
 @version $Revision$ $Date$

 */
struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource {


  /**
   * The capability status.
   */
  struct nexus_capabilities_plugin_ns0_capabilities_list_resource *data;
};

/**
 * Reads a CapabilityStatusResponseResource element from XML. The element to be read is "capability-status", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The CapabilityStatusResponseResource, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *xml_read_nexus_capabilities_plugin_ns0_capabilityStatusResponseResource(xmlTextReaderPtr reader);

/**
 * Writes a CapabilityStatusResponseResource to XML under element name "capability-status".
 *
 * @param writer The XML writer.
 * @param _capabilityStatusResponseResource The CapabilityStatusResponseResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_capabilities_plugin_ns0_capabilityStatusResponseResource(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *_capabilityStatusResponseResource);

/**
 * Frees a CapabilityStatusResponseResource.
 *
 * @param _capabilityStatusResponseResource The CapabilityStatusResponseResource to free.
 */
void free_nexus_capabilities_plugin_ns0_capabilityStatusResponseResource(struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *_capabilityStatusResponseResource);

/**
 * Reads a CapabilityStatusResponseResource element from XML. The element to be read is "capability-status", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The CapabilityStatusResponseResource, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *xmlTextReaderReadNs0Capability_statusElement(xmlTextReaderPtr reader);

/**
 * Writes a CapabilityStatusResponseResource to XML under element name "capability-status".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _capabilityStatusResponseResource The CapabilityStatusResponseResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Capability_statusElement(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *_capabilityStatusResponseResource);

/**
 * Writes a CapabilityStatusResponseResource to XML under element name "capability-status".
 *
 * @param writer The XML writer.
 * @param _capabilityStatusResponseResource The CapabilityStatusResponseResource to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Capability_statusElementNS(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *_capabilityStatusResponseResource, int writeNamespaces);

/**
 * Frees the children of a CapabilityStatusResponseResource.
 *
 * @param _capabilityStatusResponseResource The CapabilityStatusResponseResource whose children are to be free.
 */
static void freeNs0Capability_statusElement(struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *_capabilityStatusResponseResource);

/**
 * Reads a CapabilityStatusResponseResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The CapabilityStatusResponseResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *xmlTextReaderReadNs0CapabilityStatusResponseResourceType(xmlTextReaderPtr reader);

/**
 * Writes a CapabilityStatusResponseResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityStatusResponseResource The CapabilityStatusResponseResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CapabilityStatusResponseResourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *_capabilityStatusResponseResource);

/**
 * Frees the elements of a CapabilityStatusResponseResource.
 *
 * @param _capabilityStatusResponseResource The CapabilityStatusResponseResource to free.
 */
static void freeNs0CapabilityStatusResponseResourceType(struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *_capabilityStatusResponseResource);

#endif /* DEF_nexus_capabilities_plugin_ns0_capabilityStatusResponseResource_H */
#ifndef DEF_nexus_capabilities_plugin_ns0_capability_type_resource_H
#define DEF_nexus_capabilities_plugin_ns0_capability_type_resource_H

/**
 *  Capability type, which you can configure a capability against.
 
 @version $Revision$ $Date$

 */
struct nexus_capabilities_plugin_ns0_capability_type_resource {


  /**
   * The id of capability type.
   */
  xmlChar *id;

  /**
   * The name of capability type.
   */
  xmlChar *name;

  /**
   * Field formFields.
   */
  struct nexus_capabilities_plugin_ns0_capabilityFormFieldResource *formFields;

  /**
   * Size of the formFields array.
   */
  int _sizeof_formFields;
};

/**
 * Reads a CapabilityTypeResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The CapabilityTypeResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capability_type_resource *xmlTextReaderReadNs0Capability_type_resourceType(xmlTextReaderPtr reader);

/**
 * Writes a CapabilityTypeResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityTypeResource The CapabilityTypeResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Capability_type_resourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capability_type_resource *_capabilityTypeResource);

/**
 * Frees the elements of a CapabilityTypeResource.
 *
 * @param _capabilityTypeResource The CapabilityTypeResource to free.
 */
static void freeNs0Capability_type_resourceType(struct nexus_capabilities_plugin_ns0_capability_type_resource *_capabilityTypeResource);

#endif /* DEF_nexus_capabilities_plugin_ns0_capability_type_resource_H */
#ifndef DEF_nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse_H
#define DEF_nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse_H

/**
 *  REST Response object for a capability type list request,
 contains the typical 'data' parameter, which is the capability
 type details.
 
 @version $Revision$ $Date$

 */
struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse {


  /**
   * Field data.
   */
  struct nexus_capabilities_plugin_ns0_capability_type_resource *data;

  /**
   * Size of the data array.
   */
  int _sizeof_data;
};

/**
 * Reads a CapabilityTypeResourceResponse element from XML. The element to be read is "capability-types", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The CapabilityTypeResourceResponse, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *xml_read_nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse(xmlTextReaderPtr reader);

/**
 * Writes a CapabilityTypeResourceResponse to XML under element name "capability-types".
 *
 * @param writer The XML writer.
 * @param _capabilityTypeResourceResponse The CapabilityTypeResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *_capabilityTypeResourceResponse);

/**
 * Frees a CapabilityTypeResourceResponse.
 *
 * @param _capabilityTypeResourceResponse The CapabilityTypeResourceResponse to free.
 */
void free_nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse(struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *_capabilityTypeResourceResponse);

/**
 * Reads a CapabilityTypeResourceResponse element from XML. The element to be read is "capability-types", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The CapabilityTypeResourceResponse, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *xmlTextReaderReadNs0Capability_typesElement(xmlTextReaderPtr reader);

/**
 * Writes a CapabilityTypeResourceResponse to XML under element name "capability-types".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _capabilityTypeResourceResponse The CapabilityTypeResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Capability_typesElement(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *_capabilityTypeResourceResponse);

/**
 * Writes a CapabilityTypeResourceResponse to XML under element name "capability-types".
 *
 * @param writer The XML writer.
 * @param _capabilityTypeResourceResponse The CapabilityTypeResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Capability_typesElementNS(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *_capabilityTypeResourceResponse, int writeNamespaces);

/**
 * Frees the children of a CapabilityTypeResourceResponse.
 *
 * @param _capabilityTypeResourceResponse The CapabilityTypeResourceResponse whose children are to be free.
 */
static void freeNs0Capability_typesElement(struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *_capabilityTypeResourceResponse);

/**
 * Reads a CapabilityTypeResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The CapabilityTypeResourceResponse, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *xmlTextReaderReadNs0CapabilityTypeResourceResponseType(xmlTextReaderPtr reader);

/**
 * Writes a CapabilityTypeResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityTypeResourceResponse The CapabilityTypeResourceResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CapabilityTypeResourceResponseType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *_capabilityTypeResourceResponse);

/**
 * Frees the elements of a CapabilityTypeResourceResponse.
 *
 * @param _capabilityTypeResourceResponse The CapabilityTypeResourceResponse to free.
 */
static void freeNs0CapabilityTypeResourceResponseType(struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *_capabilityTypeResourceResponse);

#endif /* DEF_nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse_H */
#ifndef DEF_nexus_capabilities_plugin_ns0_form_field_H
#define DEF_nexus_capabilities_plugin_ns0_form_field_H

/**
 * (no documentation provided)
 */
struct nexus_capabilities_plugin_ns0_form_field {


  /**
   * (no documentation provided)
   */
  xmlChar *type;

  /**
   * (no documentation provided)
   */
  xmlChar *label;

  /**
   * (no documentation provided)
   */
  int required;

  /**
   * (no documentation provided)
   */
  xmlChar *id;

  /**
   * (no documentation provided)
   */
  xmlChar *regexValidation;

  /**
   * (no documentation provided)
   */
  xmlChar *helpText;
};

/**
 * Reads a FormFieldResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The FormFieldResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_form_field *xmlTextReaderReadNs0Form_fieldType(xmlTextReaderPtr reader);

/**
 * Writes a FormFieldResource to XML.
 *
 * @param writer The XML writer.
 * @param _formFieldResource The FormFieldResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Form_fieldType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_form_field *_formFieldResource);

/**
 * Frees the elements of a FormFieldResource.
 *
 * @param _formFieldResource The FormFieldResource to free.
 */
static void freeNs0Form_fieldType(struct nexus_capabilities_plugin_ns0_form_field *_formFieldResource);

#endif /* DEF_nexus_capabilities_plugin_ns0_form_field_H */
#ifndef DEF_nexus_capabilities_plugin_ns0_nexusResponse_H
#define DEF_nexus_capabilities_plugin_ns0_nexusResponse_H

/**
 * (no documentation provided)
 */
struct nexus_capabilities_plugin_ns0_nexusResponse {

};

/**
 * Reads a NexusResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The NexusResponse, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_nexusResponse *xmlTextReaderReadNs0NexusResponseType(xmlTextReaderPtr reader);

/**
 * Writes a NexusResponse to XML.
 *
 * @param writer The XML writer.
 * @param _nexusResponse The NexusResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0NexusResponseType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_nexusResponse *_nexusResponse);

/**
 * Frees the elements of a NexusResponse.
 *
 * @param _nexusResponse The NexusResponse to free.
 */
static void freeNs0NexusResponseType(struct nexus_capabilities_plugin_ns0_nexusResponse *_nexusResponse);

#endif /* DEF_nexus_capabilities_plugin_ns0_nexusResponse_H */
#ifndef DEF_nexus_capabilities_plugin_ns0_capabilitiesListResponseResource_M
#define DEF_nexus_capabilities_plugin_ns0_capabilitiesListResponseResource_M

/**
 * Reads a CapabilitiesListResponseResource element from XML. The element to be read is "capabilities-list", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The CapabilitiesListResponseResource, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *xml_read_nexus_capabilities_plugin_ns0_capabilitiesListResponseResource(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Capabilities_listElement(reader);
}

/**
 * Writes a CapabilitiesListResponseResource to XML under element name "capabilities-list".
 *
 * @param writer The XML writer.
 * @param _capabilitiesListResponseResource The CapabilitiesListResponseResource to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_capabilities_plugin_ns0_capabilitiesListResponseResource(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *_capabilitiesListResponseResource) {
  return xmlTextWriterWriteNs0Capabilities_listElementNS(writer, _capabilitiesListResponseResource, 1);
}

/**
 * Frees a CapabilitiesListResponseResource.
 *
 * @param _capabilitiesListResponseResource The CapabilitiesListResponseResource to free.
 */
void free_nexus_capabilities_plugin_ns0_capabilitiesListResponseResource(struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *_capabilitiesListResponseResource) {
  freeNs0CapabilitiesListResponseResourceType(_capabilitiesListResponseResource);
  free(_capabilitiesListResponseResource);
}

/**
 * Reads a CapabilitiesListResponseResource element from XML. The element to be read is "capabilities-list", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The CapabilitiesListResponseResource, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *xmlTextReaderReadNs0Capabilities_listElement(xmlTextReaderPtr reader) {
  struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *_capabilitiesListResponseResource = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "capabilities-list", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}capabilities-list.\n");
#endif
    _capabilitiesListResponseResource = xmlTextReaderReadNs0CapabilitiesListResponseResourceType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_capabilitiesListResponseResource == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}capabilities-list failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}capabilities-list failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _capabilitiesListResponseResource;
}

/**
 * Writes a CapabilitiesListResponseResource to XML under element name "capabilities-list".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _capabilitiesListResponseResource The CapabilitiesListResponseResource to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Capabilities_listElement(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *_capabilitiesListResponseResource) {
  return xmlTextWriterWriteNs0Capabilities_listElementNS(writer, _capabilitiesListResponseResource, 0);
}

/**
 * Writes a CapabilitiesListResponseResource to XML under element name "capabilities-list".
 *
 * @param writer The XML writer.
 * @param _capabilitiesListResponseResource The CapabilitiesListResponseResource to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Capabilities_listElementNS(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *_capabilitiesListResponseResource, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "capabilities-list", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}capabilities-list. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}capabilitiesListResponseResource for root element {}capabilities-list...\n");
#endif
  status = xmlTextWriterWriteNs0CapabilitiesListResponseResourceType(writer, _capabilitiesListResponseResource);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}capabilities-list. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}capabilities-list. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a CapabilitiesListResponseResource.
 *
 * @param _capabilitiesListResponseResource The CapabilitiesListResponseResource whose children are to be free.
 */
static void freeNs0Capabilities_listElement(struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *_capabilitiesListResponseResource) {
  freeNs0CapabilitiesListResponseResourceType(_capabilitiesListResponseResource);
}

/**
 * Reads a CapabilitiesListResponseResource from XML. The reader is assumed to be at the start element.
 *
 * @return the CapabilitiesListResponseResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *xmlTextReaderReadNs0CapabilitiesListResponseResourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *_capabilitiesListResponseResource = calloc(1, sizeof(struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0CapabilitiesListResponseResourceType(_capabilitiesListResponseResource);
        free(_capabilitiesListResponseResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}data...\n");
#endif
          //start wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0CapabilitiesListResponseResourceType(_capabilitiesListResponseResource);
              free(_capabilitiesListResponseResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "capabilities-list-item", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}capabilities-list-item of type {}capabilities-list-resource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Capabilities_list_resourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}capabilities-list-item of type {}capabilities-list-resource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CapabilitiesListResponseResourceType(_capabilitiesListResponseResource);
          free(_capabilitiesListResponseResource);
          return NULL;
        }

        _capabilitiesListResponseResource->data = realloc(_capabilitiesListResponseResource->data, (_capabilitiesListResponseResource->_sizeof_data + 1) * sizeof(struct nexus_capabilities_plugin_ns0_capabilities_list_resource));
        memcpy(&(_capabilitiesListResponseResource->data[_capabilitiesListResponseResource->_sizeof_data++]), _child_accessor, sizeof(struct nexus_capabilities_plugin_ns0_capabilities_list_resource));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}data.\n");
#endif
          freeNs0CapabilitiesListResponseResourceType(_capabilitiesListResponseResource);
          free(_capabilitiesListResponseResource);
          return NULL;
        }
        else {
          //end wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}capabilitiesListResponseResource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}capabilitiesListResponseResource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _capabilitiesListResponseResource;
}

/**
 * Writes a CapabilitiesListResponseResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilitiesListResponseResource The CapabilitiesListResponseResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0CapabilitiesListResponseResourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *_capabilitiesListResponseResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;

  if (_capabilitiesListResponseResource->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _capabilitiesListResponseResource->_sizeof_data; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "capabilities-list-item", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}capabilities-list-item. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}capabilities-list-resource for element {}capabilities-list-item...\n", status);
#endif
    status = xmlTextWriterWriteNs0Capabilities_list_resourceType(writer, &(_capabilitiesListResponseResource->data[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}capabilities-list-resource for element {}capabilities-list-item. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}capabilities-list-item. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_capabilitiesListResponseResource->data != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a CapabilitiesListResponseResource.
 *
 * @param _capabilitiesListResponseResource The CapabilitiesListResponseResource to free.
 */
static void freeNs0CapabilitiesListResponseResourceType(struct nexus_capabilities_plugin_ns0_capabilitiesListResponseResource *_capabilitiesListResponseResource) {
  int i;
  if (_capabilitiesListResponseResource->data != NULL) {
    for (i = 0; i < _capabilitiesListResponseResource->_sizeof_data; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor data[%i] of type nexus_capabilities_plugin_ns0_capabilitiesListResponseResource...\n", i);
#endif
      freeNs0Capabilities_list_resourceType(&(_capabilitiesListResponseResource->data[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_capabilities_plugin_ns0_capabilitiesListResponseResource...\n");
#endif
    free(_capabilitiesListResponseResource->data);
  }
}
#endif /* DEF_nexus_capabilities_plugin_ns0_capabilitiesListResponseResource_M */
#ifndef DEF_nexus_capabilities_plugin_ns0_capabilityFormFieldResource_M
#define DEF_nexus_capabilities_plugin_ns0_capabilityFormFieldResource_M

/**
 * Reads a CapabilityFormFieldResource from XML. The reader is assumed to be at the start element.
 *
 * @return the CapabilityFormFieldResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capabilityFormFieldResource *xmlTextReaderReadNs0CapabilityFormFieldResourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_capabilities_plugin_ns0_capabilityFormFieldResource *_capabilityFormFieldResource = calloc(1, sizeof(struct nexus_capabilities_plugin_ns0_capabilityFormFieldResource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0CapabilityFormFieldResourceType(_capabilityFormFieldResource);
        free(_capabilityFormFieldResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "type", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}type of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}type of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CapabilityFormFieldResourceType(_capabilityFormFieldResource);
          free(_capabilityFormFieldResource);
          return NULL;
        }

        _capabilityFormFieldResource->type = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "label", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}label of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}label of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CapabilityFormFieldResourceType(_capabilityFormFieldResource);
          free(_capabilityFormFieldResource);
          return NULL;
        }

        _capabilityFormFieldResource->label = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "required", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}required of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}required of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CapabilityFormFieldResourceType(_capabilityFormFieldResource);
          free(_capabilityFormFieldResource);
          return NULL;
        }

        _capabilityFormFieldResource->required = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CapabilityFormFieldResourceType(_capabilityFormFieldResource);
          free(_capabilityFormFieldResource);
          return NULL;
        }

        _capabilityFormFieldResource->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "regexValidation", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}regexValidation of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}regexValidation of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CapabilityFormFieldResourceType(_capabilityFormFieldResource);
          free(_capabilityFormFieldResource);
          return NULL;
        }

        _capabilityFormFieldResource->regexValidation = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "helpText", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}helpText of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}helpText of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CapabilityFormFieldResourceType(_capabilityFormFieldResource);
          free(_capabilityFormFieldResource);
          return NULL;
        }

        _capabilityFormFieldResource->helpText = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}capabilityFormFieldResource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}capabilityFormFieldResource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _capabilityFormFieldResource;
}

/**
 * Writes a CapabilityFormFieldResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityFormFieldResource The CapabilityFormFieldResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0CapabilityFormFieldResourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityFormFieldResource *_capabilityFormFieldResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_capabilityFormFieldResource->type != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "type", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}type. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}type...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_capabilityFormFieldResource->type));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}type. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}type. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_capabilityFormFieldResource->label != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "label", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}label. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}label...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_capabilityFormFieldResource->label));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}label. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}label. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "required", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}required. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}required...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_capabilityFormFieldResource->required));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}required. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}required. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_capabilityFormFieldResource->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_capabilityFormFieldResource->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_capabilityFormFieldResource->regexValidation != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "regexValidation", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}regexValidation. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}regexValidation...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_capabilityFormFieldResource->regexValidation));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}regexValidation. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}regexValidation. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_capabilityFormFieldResource->helpText != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "helpText", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}helpText. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}helpText...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_capabilityFormFieldResource->helpText));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}helpText. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}helpText. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a CapabilityFormFieldResource.
 *
 * @param _capabilityFormFieldResource The CapabilityFormFieldResource to free.
 */
static void freeNs0CapabilityFormFieldResourceType(struct nexus_capabilities_plugin_ns0_capabilityFormFieldResource *_capabilityFormFieldResource) {
  int i;
  if (_capabilityFormFieldResource->type != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor type of type nexus_capabilities_plugin_ns0_capabilityFormFieldResource...\n");
#endif
    freeXsStringType(_capabilityFormFieldResource->type);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor type of type nexus_capabilities_plugin_ns0_capabilityFormFieldResource...\n");
#endif
    free(_capabilityFormFieldResource->type);
  }
  if (_capabilityFormFieldResource->label != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor label of type nexus_capabilities_plugin_ns0_capabilityFormFieldResource...\n");
#endif
    freeXsStringType(_capabilityFormFieldResource->label);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor label of type nexus_capabilities_plugin_ns0_capabilityFormFieldResource...\n");
#endif
    free(_capabilityFormFieldResource->label);
  }
  if (_capabilityFormFieldResource->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_capabilities_plugin_ns0_capabilityFormFieldResource...\n");
#endif
    freeXsStringType(_capabilityFormFieldResource->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_capabilities_plugin_ns0_capabilityFormFieldResource...\n");
#endif
    free(_capabilityFormFieldResource->id);
  }
  if (_capabilityFormFieldResource->regexValidation != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor regexValidation of type nexus_capabilities_plugin_ns0_capabilityFormFieldResource...\n");
#endif
    freeXsStringType(_capabilityFormFieldResource->regexValidation);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor regexValidation of type nexus_capabilities_plugin_ns0_capabilityFormFieldResource...\n");
#endif
    free(_capabilityFormFieldResource->regexValidation);
  }
  if (_capabilityFormFieldResource->helpText != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor helpText of type nexus_capabilities_plugin_ns0_capabilityFormFieldResource...\n");
#endif
    freeXsStringType(_capabilityFormFieldResource->helpText);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor helpText of type nexus_capabilities_plugin_ns0_capabilityFormFieldResource...\n");
#endif
    free(_capabilityFormFieldResource->helpText);
  }
}
#endif /* DEF_nexus_capabilities_plugin_ns0_capabilityFormFieldResource_M */
#ifndef DEF_nexus_capabilities_plugin_ns0_capabilities_list_resource_M
#define DEF_nexus_capabilities_plugin_ns0_capabilities_list_resource_M

/**
 * Reads a CapabilityListItemResource from XML. The reader is assumed to be at the start element.
 *
 * @return the CapabilityListItemResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capabilities_list_resource *xmlTextReaderReadNs0Capabilities_list_resourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_capabilities_plugin_ns0_capabilities_list_resource *_capabilityListItemResource = calloc(1, sizeof(struct nexus_capabilities_plugin_ns0_capabilities_list_resource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Capabilities_list_resourceType(_capabilityListItemResource);
        free(_capabilityListItemResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "resourceURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Capabilities_list_resourceType(_capabilityListItemResource);
          free(_capabilityListItemResource);
          return NULL;
        }

        _capabilityListItemResource->resourceURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Capabilities_list_resourceType(_capabilityListItemResource);
          free(_capabilityListItemResource);
          return NULL;
        }

        _capabilityListItemResource->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Capabilities_list_resourceType(_capabilityListItemResource);
          free(_capabilityListItemResource);
          return NULL;
        }

        _capabilityListItemResource->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "typeId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}typeId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}typeId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Capabilities_list_resourceType(_capabilityListItemResource);
          free(_capabilityListItemResource);
          return NULL;
        }

        _capabilityListItemResource->typeId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "typeName", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}typeName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}typeName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Capabilities_list_resourceType(_capabilityListItemResource);
          free(_capabilityListItemResource);
          return NULL;
        }

        _capabilityListItemResource->typeName = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}capabilities-list-resource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}capabilities-list-resource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _capabilityListItemResource;
}

/**
 * Writes a CapabilityListItemResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityListItemResource The CapabilityListItemResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Capabilities_list_resourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilities_list_resource *_capabilityListItemResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_capabilityListItemResource->resourceURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "resourceURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_capabilityListItemResource->resourceURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_capabilityListItemResource->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_capabilityListItemResource->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_capabilityListItemResource->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_capabilityListItemResource->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_capabilityListItemResource->typeId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "typeId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}typeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}typeId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_capabilityListItemResource->typeId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}typeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}typeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_capabilityListItemResource->typeName != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "typeName", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}typeName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}typeName...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_capabilityListItemResource->typeName));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}typeName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}typeName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a CapabilityListItemResource.
 *
 * @param _capabilityListItemResource The CapabilityListItemResource to free.
 */
static void freeNs0Capabilities_list_resourceType(struct nexus_capabilities_plugin_ns0_capabilities_list_resource *_capabilityListItemResource) {
  int i;
  if (_capabilityListItemResource->resourceURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor resourceURI of type nexus_capabilities_plugin_ns0_capabilities_list_resource...\n");
#endif
    freeXsStringType(_capabilityListItemResource->resourceURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor resourceURI of type nexus_capabilities_plugin_ns0_capabilities_list_resource...\n");
#endif
    free(_capabilityListItemResource->resourceURI);
  }
  if (_capabilityListItemResource->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_capabilities_plugin_ns0_capabilities_list_resource...\n");
#endif
    freeXsStringType(_capabilityListItemResource->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_capabilities_plugin_ns0_capabilities_list_resource...\n");
#endif
    free(_capabilityListItemResource->id);
  }
  if (_capabilityListItemResource->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type nexus_capabilities_plugin_ns0_capabilities_list_resource...\n");
#endif
    freeXsStringType(_capabilityListItemResource->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type nexus_capabilities_plugin_ns0_capabilities_list_resource...\n");
#endif
    free(_capabilityListItemResource->name);
  }
  if (_capabilityListItemResource->typeId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor typeId of type nexus_capabilities_plugin_ns0_capabilities_list_resource...\n");
#endif
    freeXsStringType(_capabilityListItemResource->typeId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor typeId of type nexus_capabilities_plugin_ns0_capabilities_list_resource...\n");
#endif
    free(_capabilityListItemResource->typeId);
  }
  if (_capabilityListItemResource->typeName != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor typeName of type nexus_capabilities_plugin_ns0_capabilities_list_resource...\n");
#endif
    freeXsStringType(_capabilityListItemResource->typeName);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor typeName of type nexus_capabilities_plugin_ns0_capabilities_list_resource...\n");
#endif
    free(_capabilityListItemResource->typeName);
  }
}
#endif /* DEF_nexus_capabilities_plugin_ns0_capabilities_list_resource_M */
#ifndef DEF_nexus_capabilities_plugin_ns0_capability_property_resource_M
#define DEF_nexus_capabilities_plugin_ns0_capability_property_resource_M

/**
 * Reads a CapabilityPropertyResource from XML. The reader is assumed to be at the start element.
 *
 * @return the CapabilityPropertyResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capability_property_resource *xmlTextReaderReadNs0Capability_property_resourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_capabilities_plugin_ns0_capability_property_resource *_capabilityPropertyResource = calloc(1, sizeof(struct nexus_capabilities_plugin_ns0_capability_property_resource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Capability_property_resourceType(_capabilityPropertyResource);
        free(_capabilityPropertyResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "key", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}key of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}key of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Capability_property_resourceType(_capabilityPropertyResource);
          free(_capabilityPropertyResource);
          return NULL;
        }

        _capabilityPropertyResource->key = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "value", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}value of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}value of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Capability_property_resourceType(_capabilityPropertyResource);
          free(_capabilityPropertyResource);
          return NULL;
        }

        _capabilityPropertyResource->value = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}capability-property-resource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}capability-property-resource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _capabilityPropertyResource;
}

/**
 * Writes a CapabilityPropertyResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityPropertyResource The CapabilityPropertyResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Capability_property_resourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capability_property_resource *_capabilityPropertyResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_capabilityPropertyResource->key != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "key", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}key...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_capabilityPropertyResource->key));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_capabilityPropertyResource->value != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "value", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}value. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}value...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_capabilityPropertyResource->value));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}value. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}value. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a CapabilityPropertyResource.
 *
 * @param _capabilityPropertyResource The CapabilityPropertyResource to free.
 */
static void freeNs0Capability_property_resourceType(struct nexus_capabilities_plugin_ns0_capability_property_resource *_capabilityPropertyResource) {
  int i;
  if (_capabilityPropertyResource->key != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor key of type nexus_capabilities_plugin_ns0_capability_property_resource...\n");
#endif
    freeXsStringType(_capabilityPropertyResource->key);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor key of type nexus_capabilities_plugin_ns0_capability_property_resource...\n");
#endif
    free(_capabilityPropertyResource->key);
  }
  if (_capabilityPropertyResource->value != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor value of type nexus_capabilities_plugin_ns0_capability_property_resource...\n");
#endif
    freeXsStringType(_capabilityPropertyResource->value);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor value of type nexus_capabilities_plugin_ns0_capability_property_resource...\n");
#endif
    free(_capabilityPropertyResource->value);
  }
}
#endif /* DEF_nexus_capabilities_plugin_ns0_capability_property_resource_M */
#ifndef DEF_nexus_capabilities_plugin_ns0_capabilityRequestResource_M
#define DEF_nexus_capabilities_plugin_ns0_capabilityRequestResource_M

/**
 * Reads a CapabilityRequestResource element from XML. The element to be read is "capability", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The CapabilityRequestResource, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilityRequestResource *xml_read_nexus_capabilities_plugin_ns0_capabilityRequestResource(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0CapabilityElement(reader);
}

/**
 * Writes a CapabilityRequestResource to XML under element name "capability".
 *
 * @param writer The XML writer.
 * @param _capabilityRequestResource The CapabilityRequestResource to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_capabilities_plugin_ns0_capabilityRequestResource(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityRequestResource *_capabilityRequestResource) {
  return xmlTextWriterWriteNs0CapabilityElementNS(writer, _capabilityRequestResource, 1);
}

/**
 * Frees a CapabilityRequestResource.
 *
 * @param _capabilityRequestResource The CapabilityRequestResource to free.
 */
void free_nexus_capabilities_plugin_ns0_capabilityRequestResource(struct nexus_capabilities_plugin_ns0_capabilityRequestResource *_capabilityRequestResource) {
  freeNs0CapabilityRequestResourceType(_capabilityRequestResource);
  free(_capabilityRequestResource);
}

/**
 * Reads a CapabilityRequestResource element from XML. The element to be read is "capability", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The CapabilityRequestResource, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilityRequestResource *xmlTextReaderReadNs0CapabilityElement(xmlTextReaderPtr reader) {
  struct nexus_capabilities_plugin_ns0_capabilityRequestResource *_capabilityRequestResource = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "capability", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}capability.\n");
#endif
    _capabilityRequestResource = xmlTextReaderReadNs0CapabilityRequestResourceType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_capabilityRequestResource == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}capability failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}capability failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _capabilityRequestResource;
}

/**
 * Writes a CapabilityRequestResource to XML under element name "capability".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _capabilityRequestResource The CapabilityRequestResource to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0CapabilityElement(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityRequestResource *_capabilityRequestResource) {
  return xmlTextWriterWriteNs0CapabilityElementNS(writer, _capabilityRequestResource, 0);
}

/**
 * Writes a CapabilityRequestResource to XML under element name "capability".
 *
 * @param writer The XML writer.
 * @param _capabilityRequestResource The CapabilityRequestResource to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0CapabilityElementNS(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityRequestResource *_capabilityRequestResource, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "capability", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}capability. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}capabilityRequestResource for root element {}capability...\n");
#endif
  status = xmlTextWriterWriteNs0CapabilityRequestResourceType(writer, _capabilityRequestResource);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}capability. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}capability. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a CapabilityRequestResource.
 *
 * @param _capabilityRequestResource The CapabilityRequestResource whose children are to be free.
 */
static void freeNs0CapabilityElement(struct nexus_capabilities_plugin_ns0_capabilityRequestResource *_capabilityRequestResource) {
  freeNs0CapabilityRequestResourceType(_capabilityRequestResource);
}

/**
 * Reads a CapabilityRequestResource from XML. The reader is assumed to be at the start element.
 *
 * @return the CapabilityRequestResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capabilityRequestResource *xmlTextReaderReadNs0CapabilityRequestResourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_capabilities_plugin_ns0_capabilityRequestResource *_capabilityRequestResource = calloc(1, sizeof(struct nexus_capabilities_plugin_ns0_capabilityRequestResource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0CapabilityRequestResourceType(_capabilityRequestResource);
        free(_capabilityRequestResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}capability-resource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Capability_resourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}capability-resource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CapabilityRequestResourceType(_capabilityRequestResource);
          free(_capabilityRequestResource);
          return NULL;
        }

        _capabilityRequestResource->data = ((struct nexus_capabilities_plugin_ns0_capability_resource*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}capabilityRequestResource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}capabilityRequestResource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _capabilityRequestResource;
}

/**
 * Writes a CapabilityRequestResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityRequestResource The CapabilityRequestResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0CapabilityRequestResourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityRequestResource *_capabilityRequestResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_capabilityRequestResource->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}capability-resource for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0Capability_resourceType(writer, (_capabilityRequestResource->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}capability-resource for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a CapabilityRequestResource.
 *
 * @param _capabilityRequestResource The CapabilityRequestResource to free.
 */
static void freeNs0CapabilityRequestResourceType(struct nexus_capabilities_plugin_ns0_capabilityRequestResource *_capabilityRequestResource) {
  int i;
  if (_capabilityRequestResource->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_capabilities_plugin_ns0_capabilityRequestResource...\n");
#endif
    freeNs0Capability_resourceType(_capabilityRequestResource->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_capabilities_plugin_ns0_capabilityRequestResource...\n");
#endif
    free(_capabilityRequestResource->data);
  }
}
#endif /* DEF_nexus_capabilities_plugin_ns0_capabilityRequestResource_M */
#ifndef DEF_nexus_capabilities_plugin_ns0_capability_resource_M
#define DEF_nexus_capabilities_plugin_ns0_capability_resource_M

/**
 * Reads a CapabilityResource from XML. The reader is assumed to be at the start element.
 *
 * @return the CapabilityResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capability_resource *xmlTextReaderReadNs0Capability_resourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_capabilities_plugin_ns0_capability_resource *_capabilityResource = calloc(1, sizeof(struct nexus_capabilities_plugin_ns0_capability_resource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Capability_resourceType(_capabilityResource);
        free(_capabilityResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Capability_resourceType(_capabilityResource);
          free(_capabilityResource);
          return NULL;
        }

        _capabilityResource->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Capability_resourceType(_capabilityResource);
          free(_capabilityResource);
          return NULL;
        }

        _capabilityResource->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "typeId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}typeId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}typeId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Capability_resourceType(_capabilityResource);
          free(_capabilityResource);
          return NULL;
        }

        _capabilityResource->typeId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "properties", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}properties...\n");
#endif
          //start wrapper element "{}properties"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0Capability_resourceType(_capabilityResource);
              free(_capabilityResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "capability-property", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}capability-property of type {}capability-property-resource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Capability_property_resourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}capability-property of type {}capability-property-resource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Capability_resourceType(_capabilityResource);
          free(_capabilityResource);
          return NULL;
        }

        _capabilityResource->properties = realloc(_capabilityResource->properties, (_capabilityResource->_sizeof_properties + 1) * sizeof(struct nexus_capabilities_plugin_ns0_capability_property_resource));
        memcpy(&(_capabilityResource->properties[_capabilityResource->_sizeof_properties++]), _child_accessor, sizeof(struct nexus_capabilities_plugin_ns0_capability_property_resource));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}properties.\n");
#endif
          freeNs0Capability_resourceType(_capabilityResource);
          free(_capabilityResource);
          return NULL;
        }
        else {
          //end wrapper element "{}properties"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}capability-resource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}capability-resource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _capabilityResource;
}

/**
 * Writes a CapabilityResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityResource The CapabilityResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Capability_resourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capability_resource *_capabilityResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_capabilityResource->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_capabilityResource->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_capabilityResource->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_capabilityResource->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_capabilityResource->typeId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "typeId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}typeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}typeId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_capabilityResource->typeId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}typeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}typeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_capabilityResource->properties != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "properties", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}properties. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _capabilityResource->_sizeof_properties; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "capability-property", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}capability-property. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}capability-property-resource for element {}capability-property...\n", status);
#endif
    status = xmlTextWriterWriteNs0Capability_property_resourceType(writer, &(_capabilityResource->properties[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}capability-property-resource for element {}capability-property. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}capability-property. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_capabilityResource->properties != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}properties. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a CapabilityResource.
 *
 * @param _capabilityResource The CapabilityResource to free.
 */
static void freeNs0Capability_resourceType(struct nexus_capabilities_plugin_ns0_capability_resource *_capabilityResource) {
  int i;
  if (_capabilityResource->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_capabilities_plugin_ns0_capability_resource...\n");
#endif
    freeXsStringType(_capabilityResource->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_capabilities_plugin_ns0_capability_resource...\n");
#endif
    free(_capabilityResource->id);
  }
  if (_capabilityResource->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type nexus_capabilities_plugin_ns0_capability_resource...\n");
#endif
    freeXsStringType(_capabilityResource->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type nexus_capabilities_plugin_ns0_capability_resource...\n");
#endif
    free(_capabilityResource->name);
  }
  if (_capabilityResource->typeId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor typeId of type nexus_capabilities_plugin_ns0_capability_resource...\n");
#endif
    freeXsStringType(_capabilityResource->typeId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor typeId of type nexus_capabilities_plugin_ns0_capability_resource...\n");
#endif
    free(_capabilityResource->typeId);
  }
  if (_capabilityResource->properties != NULL) {
    for (i = 0; i < _capabilityResource->_sizeof_properties; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor properties[%i] of type nexus_capabilities_plugin_ns0_capability_resource...\n", i);
#endif
      freeNs0Capability_property_resourceType(&(_capabilityResource->properties[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor properties of type nexus_capabilities_plugin_ns0_capability_resource...\n");
#endif
    free(_capabilityResource->properties);
  }
}
#endif /* DEF_nexus_capabilities_plugin_ns0_capability_resource_M */
#ifndef DEF_nexus_capabilities_plugin_ns0_capabilityResponseResource_M
#define DEF_nexus_capabilities_plugin_ns0_capabilityResponseResource_M

/**
 * Reads a CapabilityResponseResource element from XML. The element to be read is "capability", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The CapabilityResponseResource, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilityResponseResource *xml_read_nexus_capabilities_plugin_ns0_capabilityResponseResource(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0CapabilityElement(reader);
}

/**
 * Writes a CapabilityResponseResource to XML under element name "capability".
 *
 * @param writer The XML writer.
 * @param _capabilityResponseResource The CapabilityResponseResource to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_capabilities_plugin_ns0_capabilityResponseResource(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityResponseResource *_capabilityResponseResource) {
  return xmlTextWriterWriteNs0CapabilityElementNS(writer, _capabilityResponseResource, 1);
}

/**
 * Frees a CapabilityResponseResource.
 *
 * @param _capabilityResponseResource The CapabilityResponseResource to free.
 */
void free_nexus_capabilities_plugin_ns0_capabilityResponseResource(struct nexus_capabilities_plugin_ns0_capabilityResponseResource *_capabilityResponseResource) {
  freeNs0CapabilityResponseResourceType(_capabilityResponseResource);
  free(_capabilityResponseResource);
}

/**
 * Reads a CapabilityResponseResource element from XML. The element to be read is "capability", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The CapabilityResponseResource, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilityResponseResource *xmlTextReaderReadNs0CapabilityElement(xmlTextReaderPtr reader) {
  struct nexus_capabilities_plugin_ns0_capabilityResponseResource *_capabilityResponseResource = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "capability", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}capability.\n");
#endif
    _capabilityResponseResource = xmlTextReaderReadNs0CapabilityResponseResourceType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_capabilityResponseResource == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}capability failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}capability failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _capabilityResponseResource;
}

/**
 * Writes a CapabilityResponseResource to XML under element name "capability".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _capabilityResponseResource The CapabilityResponseResource to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0CapabilityElement(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityResponseResource *_capabilityResponseResource) {
  return xmlTextWriterWriteNs0CapabilityElementNS(writer, _capabilityResponseResource, 0);
}

/**
 * Writes a CapabilityResponseResource to XML under element name "capability".
 *
 * @param writer The XML writer.
 * @param _capabilityResponseResource The CapabilityResponseResource to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0CapabilityElementNS(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityResponseResource *_capabilityResponseResource, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "capability", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}capability. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}capabilityResponseResource for root element {}capability...\n");
#endif
  status = xmlTextWriterWriteNs0CapabilityResponseResourceType(writer, _capabilityResponseResource);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}capability. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}capability. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a CapabilityResponseResource.
 *
 * @param _capabilityResponseResource The CapabilityResponseResource whose children are to be free.
 */
static void freeNs0CapabilityElement(struct nexus_capabilities_plugin_ns0_capabilityResponseResource *_capabilityResponseResource) {
  freeNs0CapabilityResponseResourceType(_capabilityResponseResource);
}

/**
 * Reads a CapabilityResponseResource from XML. The reader is assumed to be at the start element.
 *
 * @return the CapabilityResponseResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capabilityResponseResource *xmlTextReaderReadNs0CapabilityResponseResourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_capabilities_plugin_ns0_capabilityResponseResource *_capabilityResponseResource = calloc(1, sizeof(struct nexus_capabilities_plugin_ns0_capabilityResponseResource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0CapabilityResponseResourceType(_capabilityResponseResource);
        free(_capabilityResponseResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}capability-resource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Capability_resourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}capability-resource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CapabilityResponseResourceType(_capabilityResponseResource);
          free(_capabilityResponseResource);
          return NULL;
        }

        _capabilityResponseResource->data = ((struct nexus_capabilities_plugin_ns0_capability_resource*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}capabilityResponseResource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}capabilityResponseResource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _capabilityResponseResource;
}

/**
 * Writes a CapabilityResponseResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityResponseResource The CapabilityResponseResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0CapabilityResponseResourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityResponseResource *_capabilityResponseResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_capabilityResponseResource->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}capability-resource for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0Capability_resourceType(writer, (_capabilityResponseResource->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}capability-resource for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a CapabilityResponseResource.
 *
 * @param _capabilityResponseResource The CapabilityResponseResource to free.
 */
static void freeNs0CapabilityResponseResourceType(struct nexus_capabilities_plugin_ns0_capabilityResponseResource *_capabilityResponseResource) {
  int i;
  if (_capabilityResponseResource->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_capabilities_plugin_ns0_capabilityResponseResource...\n");
#endif
    freeNs0Capability_resourceType(_capabilityResponseResource->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_capabilities_plugin_ns0_capabilityResponseResource...\n");
#endif
    free(_capabilityResponseResource->data);
  }
}
#endif /* DEF_nexus_capabilities_plugin_ns0_capabilityResponseResource_M */
#ifndef DEF_nexus_capabilities_plugin_ns0_capabilityStatusResponseResource_M
#define DEF_nexus_capabilities_plugin_ns0_capabilityStatusResponseResource_M

/**
 * Reads a CapabilityStatusResponseResource element from XML. The element to be read is "capability-status", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The CapabilityStatusResponseResource, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *xml_read_nexus_capabilities_plugin_ns0_capabilityStatusResponseResource(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Capability_statusElement(reader);
}

/**
 * Writes a CapabilityStatusResponseResource to XML under element name "capability-status".
 *
 * @param writer The XML writer.
 * @param _capabilityStatusResponseResource The CapabilityStatusResponseResource to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_capabilities_plugin_ns0_capabilityStatusResponseResource(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *_capabilityStatusResponseResource) {
  return xmlTextWriterWriteNs0Capability_statusElementNS(writer, _capabilityStatusResponseResource, 1);
}

/**
 * Frees a CapabilityStatusResponseResource.
 *
 * @param _capabilityStatusResponseResource The CapabilityStatusResponseResource to free.
 */
void free_nexus_capabilities_plugin_ns0_capabilityStatusResponseResource(struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *_capabilityStatusResponseResource) {
  freeNs0CapabilityStatusResponseResourceType(_capabilityStatusResponseResource);
  free(_capabilityStatusResponseResource);
}

/**
 * Reads a CapabilityStatusResponseResource element from XML. The element to be read is "capability-status", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The CapabilityStatusResponseResource, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *xmlTextReaderReadNs0Capability_statusElement(xmlTextReaderPtr reader) {
  struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *_capabilityStatusResponseResource = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "capability-status", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}capability-status.\n");
#endif
    _capabilityStatusResponseResource = xmlTextReaderReadNs0CapabilityStatusResponseResourceType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_capabilityStatusResponseResource == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}capability-status failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}capability-status failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _capabilityStatusResponseResource;
}

/**
 * Writes a CapabilityStatusResponseResource to XML under element name "capability-status".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _capabilityStatusResponseResource The CapabilityStatusResponseResource to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Capability_statusElement(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *_capabilityStatusResponseResource) {
  return xmlTextWriterWriteNs0Capability_statusElementNS(writer, _capabilityStatusResponseResource, 0);
}

/**
 * Writes a CapabilityStatusResponseResource to XML under element name "capability-status".
 *
 * @param writer The XML writer.
 * @param _capabilityStatusResponseResource The CapabilityStatusResponseResource to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Capability_statusElementNS(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *_capabilityStatusResponseResource, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "capability-status", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}capability-status. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}capabilityStatusResponseResource for root element {}capability-status...\n");
#endif
  status = xmlTextWriterWriteNs0CapabilityStatusResponseResourceType(writer, _capabilityStatusResponseResource);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}capability-status. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}capability-status. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a CapabilityStatusResponseResource.
 *
 * @param _capabilityStatusResponseResource The CapabilityStatusResponseResource whose children are to be free.
 */
static void freeNs0Capability_statusElement(struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *_capabilityStatusResponseResource) {
  freeNs0CapabilityStatusResponseResourceType(_capabilityStatusResponseResource);
}

/**
 * Reads a CapabilityStatusResponseResource from XML. The reader is assumed to be at the start element.
 *
 * @return the CapabilityStatusResponseResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *xmlTextReaderReadNs0CapabilityStatusResponseResourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *_capabilityStatusResponseResource = calloc(1, sizeof(struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0CapabilityStatusResponseResourceType(_capabilityStatusResponseResource);
        free(_capabilityStatusResponseResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}capabilities-list-resource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Capabilities_list_resourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}capabilities-list-resource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CapabilityStatusResponseResourceType(_capabilityStatusResponseResource);
          free(_capabilityStatusResponseResource);
          return NULL;
        }

        _capabilityStatusResponseResource->data = ((struct nexus_capabilities_plugin_ns0_capabilities_list_resource*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}capabilityStatusResponseResource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}capabilityStatusResponseResource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _capabilityStatusResponseResource;
}

/**
 * Writes a CapabilityStatusResponseResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityStatusResponseResource The CapabilityStatusResponseResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0CapabilityStatusResponseResourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *_capabilityStatusResponseResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_capabilityStatusResponseResource->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}capabilities-list-resource for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0Capabilities_list_resourceType(writer, (_capabilityStatusResponseResource->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}capabilities-list-resource for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a CapabilityStatusResponseResource.
 *
 * @param _capabilityStatusResponseResource The CapabilityStatusResponseResource to free.
 */
static void freeNs0CapabilityStatusResponseResourceType(struct nexus_capabilities_plugin_ns0_capabilityStatusResponseResource *_capabilityStatusResponseResource) {
  int i;
  if (_capabilityStatusResponseResource->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_capabilities_plugin_ns0_capabilityStatusResponseResource...\n");
#endif
    freeNs0Capabilities_list_resourceType(_capabilityStatusResponseResource->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_capabilities_plugin_ns0_capabilityStatusResponseResource...\n");
#endif
    free(_capabilityStatusResponseResource->data);
  }
}
#endif /* DEF_nexus_capabilities_plugin_ns0_capabilityStatusResponseResource_M */
#ifndef DEF_nexus_capabilities_plugin_ns0_capability_type_resource_M
#define DEF_nexus_capabilities_plugin_ns0_capability_type_resource_M

/**
 * Reads a CapabilityTypeResource from XML. The reader is assumed to be at the start element.
 *
 * @return the CapabilityTypeResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capability_type_resource *xmlTextReaderReadNs0Capability_type_resourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_capabilities_plugin_ns0_capability_type_resource *_capabilityTypeResource = calloc(1, sizeof(struct nexus_capabilities_plugin_ns0_capability_type_resource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Capability_type_resourceType(_capabilityTypeResource);
        free(_capabilityTypeResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Capability_type_resourceType(_capabilityTypeResource);
          free(_capabilityTypeResource);
          return NULL;
        }

        _capabilityTypeResource->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Capability_type_resourceType(_capabilityTypeResource);
          free(_capabilityTypeResource);
          return NULL;
        }

        _capabilityTypeResource->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "form-fields", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}form-fields...\n");
#endif
          //start wrapper element "{}form-fields"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0Capability_type_resourceType(_capabilityTypeResource);
              free(_capabilityTypeResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "form-field", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}form-field of type {}capabilityFormFieldResource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0CapabilityFormFieldResourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}form-field of type {}capabilityFormFieldResource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Capability_type_resourceType(_capabilityTypeResource);
          free(_capabilityTypeResource);
          return NULL;
        }

        _capabilityTypeResource->formFields = realloc(_capabilityTypeResource->formFields, (_capabilityTypeResource->_sizeof_formFields + 1) * sizeof(struct nexus_capabilities_plugin_ns0_capabilityFormFieldResource));
        memcpy(&(_capabilityTypeResource->formFields[_capabilityTypeResource->_sizeof_formFields++]), _child_accessor, sizeof(struct nexus_capabilities_plugin_ns0_capabilityFormFieldResource));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}form-fields.\n");
#endif
          freeNs0Capability_type_resourceType(_capabilityTypeResource);
          free(_capabilityTypeResource);
          return NULL;
        }
        else {
          //end wrapper element "{}form-fields"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}capability-type-resource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}capability-type-resource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _capabilityTypeResource;
}

/**
 * Writes a CapabilityTypeResource to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityTypeResource The CapabilityTypeResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Capability_type_resourceType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capability_type_resource *_capabilityTypeResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_capabilityTypeResource->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_capabilityTypeResource->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_capabilityTypeResource->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_capabilityTypeResource->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_capabilityTypeResource->formFields != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "form-fields", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}form-fields. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _capabilityTypeResource->_sizeof_formFields; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "form-field", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}form-field. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}capabilityFormFieldResource for element {}form-field...\n", status);
#endif
    status = xmlTextWriterWriteNs0CapabilityFormFieldResourceType(writer, &(_capabilityTypeResource->formFields[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}capabilityFormFieldResource for element {}form-field. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}form-field. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_capabilityTypeResource->formFields != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}form-fields. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a CapabilityTypeResource.
 *
 * @param _capabilityTypeResource The CapabilityTypeResource to free.
 */
static void freeNs0Capability_type_resourceType(struct nexus_capabilities_plugin_ns0_capability_type_resource *_capabilityTypeResource) {
  int i;
  if (_capabilityTypeResource->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_capabilities_plugin_ns0_capability_type_resource...\n");
#endif
    freeXsStringType(_capabilityTypeResource->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_capabilities_plugin_ns0_capability_type_resource...\n");
#endif
    free(_capabilityTypeResource->id);
  }
  if (_capabilityTypeResource->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type nexus_capabilities_plugin_ns0_capability_type_resource...\n");
#endif
    freeXsStringType(_capabilityTypeResource->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type nexus_capabilities_plugin_ns0_capability_type_resource...\n");
#endif
    free(_capabilityTypeResource->name);
  }
  if (_capabilityTypeResource->formFields != NULL) {
    for (i = 0; i < _capabilityTypeResource->_sizeof_formFields; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor formFields[%i] of type nexus_capabilities_plugin_ns0_capability_type_resource...\n", i);
#endif
      freeNs0CapabilityFormFieldResourceType(&(_capabilityTypeResource->formFields[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor formFields of type nexus_capabilities_plugin_ns0_capability_type_resource...\n");
#endif
    free(_capabilityTypeResource->formFields);
  }
}
#endif /* DEF_nexus_capabilities_plugin_ns0_capability_type_resource_M */
#ifndef DEF_nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse_M
#define DEF_nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse_M

/**
 * Reads a CapabilityTypeResourceResponse element from XML. The element to be read is "capability-types", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The CapabilityTypeResourceResponse, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *xml_read_nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Capability_typesElement(reader);
}

/**
 * Writes a CapabilityTypeResourceResponse to XML under element name "capability-types".
 *
 * @param writer The XML writer.
 * @param _capabilityTypeResourceResponse The CapabilityTypeResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *_capabilityTypeResourceResponse) {
  return xmlTextWriterWriteNs0Capability_typesElementNS(writer, _capabilityTypeResourceResponse, 1);
}

/**
 * Frees a CapabilityTypeResourceResponse.
 *
 * @param _capabilityTypeResourceResponse The CapabilityTypeResourceResponse to free.
 */
void free_nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse(struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *_capabilityTypeResourceResponse) {
  freeNs0CapabilityTypeResourceResponseType(_capabilityTypeResourceResponse);
  free(_capabilityTypeResourceResponse);
}

/**
 * Reads a CapabilityTypeResourceResponse element from XML. The element to be read is "capability-types", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The CapabilityTypeResourceResponse, or NULL in case of error.
 */
struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *xmlTextReaderReadNs0Capability_typesElement(xmlTextReaderPtr reader) {
  struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *_capabilityTypeResourceResponse = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "capability-types", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}capability-types.\n");
#endif
    _capabilityTypeResourceResponse = xmlTextReaderReadNs0CapabilityTypeResourceResponseType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_capabilityTypeResourceResponse == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}capability-types failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}capability-types failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _capabilityTypeResourceResponse;
}

/**
 * Writes a CapabilityTypeResourceResponse to XML under element name "capability-types".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _capabilityTypeResourceResponse The CapabilityTypeResourceResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Capability_typesElement(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *_capabilityTypeResourceResponse) {
  return xmlTextWriterWriteNs0Capability_typesElementNS(writer, _capabilityTypeResourceResponse, 0);
}

/**
 * Writes a CapabilityTypeResourceResponse to XML under element name "capability-types".
 *
 * @param writer The XML writer.
 * @param _capabilityTypeResourceResponse The CapabilityTypeResourceResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Capability_typesElementNS(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *_capabilityTypeResourceResponse, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "capability-types", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}capability-types. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}capabilityTypeResourceResponse for root element {}capability-types...\n");
#endif
  status = xmlTextWriterWriteNs0CapabilityTypeResourceResponseType(writer, _capabilityTypeResourceResponse);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}capability-types. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}capability-types. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a CapabilityTypeResourceResponse.
 *
 * @param _capabilityTypeResourceResponse The CapabilityTypeResourceResponse whose children are to be free.
 */
static void freeNs0Capability_typesElement(struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *_capabilityTypeResourceResponse) {
  freeNs0CapabilityTypeResourceResponseType(_capabilityTypeResourceResponse);
}

/**
 * Reads a CapabilityTypeResourceResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the CapabilityTypeResourceResponse, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *xmlTextReaderReadNs0CapabilityTypeResourceResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *_capabilityTypeResourceResponse = calloc(1, sizeof(struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0CapabilityTypeResourceResponseType(_capabilityTypeResourceResponse);
        free(_capabilityTypeResourceResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}data...\n");
#endif
          //start wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0CapabilityTypeResourceResponseType(_capabilityTypeResourceResponse);
              free(_capabilityTypeResourceResponse);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "capability-type", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}capability-type of type {}capability-type-resource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Capability_type_resourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}capability-type of type {}capability-type-resource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CapabilityTypeResourceResponseType(_capabilityTypeResourceResponse);
          free(_capabilityTypeResourceResponse);
          return NULL;
        }

        _capabilityTypeResourceResponse->data = realloc(_capabilityTypeResourceResponse->data, (_capabilityTypeResourceResponse->_sizeof_data + 1) * sizeof(struct nexus_capabilities_plugin_ns0_capability_type_resource));
        memcpy(&(_capabilityTypeResourceResponse->data[_capabilityTypeResourceResponse->_sizeof_data++]), _child_accessor, sizeof(struct nexus_capabilities_plugin_ns0_capability_type_resource));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}data.\n");
#endif
          freeNs0CapabilityTypeResourceResponseType(_capabilityTypeResourceResponse);
          free(_capabilityTypeResourceResponse);
          return NULL;
        }
        else {
          //end wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}capabilityTypeResourceResponse.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}capabilityTypeResourceResponse. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _capabilityTypeResourceResponse;
}

/**
 * Writes a CapabilityTypeResourceResponse to XML.
 *
 * @param writer The XML writer.
 * @param _capabilityTypeResourceResponse The CapabilityTypeResourceResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0CapabilityTypeResourceResponseType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *_capabilityTypeResourceResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;

  if (_capabilityTypeResourceResponse->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _capabilityTypeResourceResponse->_sizeof_data; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "capability-type", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}capability-type. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}capability-type-resource for element {}capability-type...\n", status);
#endif
    status = xmlTextWriterWriteNs0Capability_type_resourceType(writer, &(_capabilityTypeResourceResponse->data[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}capability-type-resource for element {}capability-type. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}capability-type. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_capabilityTypeResourceResponse->data != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a CapabilityTypeResourceResponse.
 *
 * @param _capabilityTypeResourceResponse The CapabilityTypeResourceResponse to free.
 */
static void freeNs0CapabilityTypeResourceResponseType(struct nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse *_capabilityTypeResourceResponse) {
  int i;
  if (_capabilityTypeResourceResponse->data != NULL) {
    for (i = 0; i < _capabilityTypeResourceResponse->_sizeof_data; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor data[%i] of type nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse...\n", i);
#endif
      freeNs0Capability_type_resourceType(&(_capabilityTypeResourceResponse->data[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse...\n");
#endif
    free(_capabilityTypeResourceResponse->data);
  }
}
#endif /* DEF_nexus_capabilities_plugin_ns0_capabilityTypeResourceResponse_M */
#ifndef DEF_nexus_capabilities_plugin_ns0_form_field_M
#define DEF_nexus_capabilities_plugin_ns0_form_field_M

/**
 * Reads a FormFieldResource from XML. The reader is assumed to be at the start element.
 *
 * @return the FormFieldResource, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_form_field *xmlTextReaderReadNs0Form_fieldType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_capabilities_plugin_ns0_form_field *_formFieldResource = calloc(1, sizeof(struct nexus_capabilities_plugin_ns0_form_field));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Form_fieldType(_formFieldResource);
        free(_formFieldResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "type", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}type of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}type of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Form_fieldType(_formFieldResource);
          free(_formFieldResource);
          return NULL;
        }

        _formFieldResource->type = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "label", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}label of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}label of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Form_fieldType(_formFieldResource);
          free(_formFieldResource);
          return NULL;
        }

        _formFieldResource->label = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "required", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}required of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}required of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Form_fieldType(_formFieldResource);
          free(_formFieldResource);
          return NULL;
        }

        _formFieldResource->required = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Form_fieldType(_formFieldResource);
          free(_formFieldResource);
          return NULL;
        }

        _formFieldResource->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "regexValidation", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}regexValidation of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}regexValidation of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Form_fieldType(_formFieldResource);
          free(_formFieldResource);
          return NULL;
        }

        _formFieldResource->regexValidation = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "helpText", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}helpText of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}helpText of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Form_fieldType(_formFieldResource);
          free(_formFieldResource);
          return NULL;
        }

        _formFieldResource->helpText = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}form-field.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}form-field. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _formFieldResource;
}

/**
 * Writes a FormFieldResource to XML.
 *
 * @param writer The XML writer.
 * @param _formFieldResource The FormFieldResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Form_fieldType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_form_field *_formFieldResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_formFieldResource->type != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "type", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}type. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}type...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_formFieldResource->type));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}type. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}type. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_formFieldResource->label != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "label", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}label. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}label...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_formFieldResource->label));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}label. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}label. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "required", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}required. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}required...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_formFieldResource->required));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}required. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}required. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_formFieldResource->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_formFieldResource->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_formFieldResource->regexValidation != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "regexValidation", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}regexValidation. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}regexValidation...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_formFieldResource->regexValidation));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}regexValidation. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}regexValidation. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_formFieldResource->helpText != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "helpText", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}helpText. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}helpText...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_formFieldResource->helpText));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}helpText. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}helpText. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a FormFieldResource.
 *
 * @param _formFieldResource The FormFieldResource to free.
 */
static void freeNs0Form_fieldType(struct nexus_capabilities_plugin_ns0_form_field *_formFieldResource) {
  int i;
  if (_formFieldResource->type != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor type of type nexus_capabilities_plugin_ns0_form_field...\n");
#endif
    freeXsStringType(_formFieldResource->type);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor type of type nexus_capabilities_plugin_ns0_form_field...\n");
#endif
    free(_formFieldResource->type);
  }
  if (_formFieldResource->label != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor label of type nexus_capabilities_plugin_ns0_form_field...\n");
#endif
    freeXsStringType(_formFieldResource->label);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor label of type nexus_capabilities_plugin_ns0_form_field...\n");
#endif
    free(_formFieldResource->label);
  }
  if (_formFieldResource->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_capabilities_plugin_ns0_form_field...\n");
#endif
    freeXsStringType(_formFieldResource->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_capabilities_plugin_ns0_form_field...\n");
#endif
    free(_formFieldResource->id);
  }
  if (_formFieldResource->regexValidation != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor regexValidation of type nexus_capabilities_plugin_ns0_form_field...\n");
#endif
    freeXsStringType(_formFieldResource->regexValidation);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor regexValidation of type nexus_capabilities_plugin_ns0_form_field...\n");
#endif
    free(_formFieldResource->regexValidation);
  }
  if (_formFieldResource->helpText != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor helpText of type nexus_capabilities_plugin_ns0_form_field...\n");
#endif
    freeXsStringType(_formFieldResource->helpText);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor helpText of type nexus_capabilities_plugin_ns0_form_field...\n");
#endif
    free(_formFieldResource->helpText);
  }
}
#endif /* DEF_nexus_capabilities_plugin_ns0_form_field_M */
#ifndef DEF_nexus_capabilities_plugin_ns0_nexusResponse_M
#define DEF_nexus_capabilities_plugin_ns0_nexusResponse_M

/**
 * Reads a NexusResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the NexusResponse, or NULL in case of error.
 */
static struct nexus_capabilities_plugin_ns0_nexusResponse *xmlTextReaderReadNs0NexusResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_capabilities_plugin_ns0_nexusResponse *_nexusResponse = calloc(1, sizeof(struct nexus_capabilities_plugin_ns0_nexusResponse));




  return _nexusResponse;
}

/**
 * Writes a NexusResponse to XML.
 *
 * @param writer The XML writer.
 * @param _nexusResponse The NexusResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0NexusResponseType(xmlTextWriterPtr writer, struct nexus_capabilities_plugin_ns0_nexusResponse *_nexusResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;

  return totalBytes;
}

/**
 * Frees the elements of a NexusResponse.
 *
 * @param _nexusResponse The NexusResponse to free.
 */
static void freeNs0NexusResponseType(struct nexus_capabilities_plugin_ns0_nexusResponse *_nexusResponse) {
  int i;
}
#endif /* DEF_nexus_capabilities_plugin_ns0_nexusResponse_M */
